       IDENTIFICATION DIVISION.
       PROGRAM-ID. VCON140.
      *
      * Stampa registri IVA con sort per data e n.reg.
      *
      * Oltre ai valori soliti, FUN puo' valere anche:
      * M = caricamento dati del prospetto liquidazione IVA a video
      * w = valida tutto dati 2a videata (db2)
      * S = rientro nella run-elabora dopo la richiesta dati
      *     occorrenti per chiamare vcon145.
      *     Da lanciare dopo la 'R' se IF-HS-145 = 1
      * 
      * Nota: il file di lavoro wds142, viene generato da vcon142 ed
      *       utilizzato da vcon143.
      *       Questo programma si occupa solo della sua cancellazione
      *       al termine. 
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'grimovsl'.
           COPY 'grimvxsl'.
           COPY 'grimolsl'.
           COPY 'grimmosl'.
           COPY 'griivtsl'.
           COPY 'griivasl'.
           COPY 'gritabsl'.
           COPY 'gri142sl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED 
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS 
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'grimov'.  
           COPY 'grimvx'.
           COPY 'grimol'.
           COPY 'grimmo'.
           COPY 'griivt'.  
           COPY 'griiva'.
           COPY 'gritab'.
      * file di lavoro usato da vcon142 e da vcon143
           COPY 'gri142'.
      *
       FD  WDSLAV LABEL RECORD STANDARD 
           VALUE OF FILE-ID ID-LAV
           RECORD 158 DATA RECORD RF-LAV.
       01  RF-LAV.
           05 KEYLV.
              10 KLV-DAT   PIC 9(5).
              10 KLV-NPRGI PIC 9(5) COMP-3.
              10 KLV-CDCLI PIC 9(7) COMP-3.
              10 KLV-NREG  PIC 9(5) COMP-3.
              10 KLV-IVA   PIC 999.
              10 KLV-NUM   PIC 9(5) COMP-3.
           05 LAV-CIVA     PIC 9(7).
           05 LAV-RMOV     PIC X(130).
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parmb'.
           COPY 'pariv'.
           COPY 'parpsb'.
           COPY 'parlk'.
           COPY 'pardmi'.
      **** rel 7.2
           COPY 'pargiso-72'.
           COPY 'prfisc'.
           COPY 'prpiva'.
      ************
           COPY 'griazirk'.
           COPY 'gritabrk'.   
           COPY 'grit35rk'.
           COPY 'grit25rk'.
           COPY 'grimovrk'. 
           COPY 'griivark'.
           COPY 'griclfrk'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-MOV PIC X(15) VALUE 'movime'.
       01  ID-MVX PIC X(15) VALUE 'movmxx'.
       01  ID-MOL PIC X(15) VALUE 'movmol'.
       01  ID-MMO PIC X(15) VALUE 'movoxx'.
       01  ID-IVT PIC X(15) VALUE 'movivt'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-142 PIC X(15) VALUE 'wds142'.
       01  ID-IVA PIC X(15) VALUE 'totiva'.
      * parametri per vcon143
       01  PARLINK-143.
           05 FL-143     PIC 9.
           05 ID-TAB-143 PIC X(15).
           05 ID-IVA-143 PIC X(15).
           05 TOTIV-143  PIC S9(11)V99.
           05 RIMB-143   PIC S9(11)V99.
           05 COMPE-143  PIC S9(11)V99.
           05 ACCIVA-143 PIC S9(11)V99.
           05 NMES-143   PIC 99.
           05 T25ESE-143 PIC 9.
           05 DTVEK-143  PIC 9(5) COMP-3.
      * parametri per vcon142
       01  PARLINK-142.
           05 ID-IVA-142 PIC X(15).
           05 ID-TAB-142 PIC X(15).
      * parametri per vcon145
       01  PARLINK-145.
           05 ID-AZI-145  PIC X(15).
           05 ID-TAB-145  PIC X(15).
           05 ID-MOV-145  PIC X(15).
           05 FL-145      PIC 9.
           05 CDAZ-145    PIC 9(3).
           05 DTCON-145   PIC 9(6).
           05 DSAGG-145   PIC X(26).
      *
       01  COMODI.
           05 SF-AZI PIC XX.
           05 SF-CLF PIC XX.
           05 SF-TAB PIC XX.
           05 SF-MOV PIC XX.
           05 SF-MVX PIC XX.
           05 SF-MOL PIC XX.
           05 SF-MMO PIC XX.
           05 SF-IVT PIC XX.
           05 SF-LAV PIC XX.
           05 SF-142 PIC XX.
           05 SF-IVA PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
      *
           05 ANNO4    PIC 9(4).
           05 DTBIG    PIC 9(5).
           05 SW-BGB   PIC 9.
           05 DTRIN    PIC 9(6).
           05 UNAS     PIC 9(5).
           05 DTAPE    PIC 9(5).
           05 NUMMOV   PIC 9(5).
           05 NUMREG   PIC 9(5).
           05 COM-FLVEN PIC 9 VALUE ZERO.
           05 COM-FEV   PIC 9 VALUE ZERO.
           05 SEGNO     PIC 9 VALUE ZERO.
           05 TIPOP     PIC 9 VALUE ZERO.
           05 DTCOM  PIC 9(5) COMP-3 VALUE ZERO.
           05 DATAS  PIC 9(5) COMP-3 VALUE ZERO.
           05 NUMIN PIC 9(5) VALUE ZERO.
           05 NUMAX PIC 9(5) VALUE ZERO.
           05 COMODO PIC S9(11)V99 VALUE ZERO.
           05 FLGIS PIC 9 VALUE ZERO.
           05 CIVSO PIC 9(7) COMP-3 VALUE ZERO.
           05 COMCAU   PIC 9(3)   VALUE ZERO.
           05 AGGTR PIC 9 VALUE ZERO.
           05 K PIC 999 VALUE ZERO.
           05 N PIC 999 VALUE ZERO.
           05 CLAV PIC S9(11)V99.
           05 CLV1 PIC S9(11)V99.
           05 CLV2 PIC S9(11)V99.
           05 CIVA PIC 9(7) COMP-3.
           05 INFI.
              10 AL7 PIC X(7) VALUE 'INIZIO '.
              10 FILLER PIC X(20) VALUE 'STAMPA LIBRO BOLLATO'.
           05 CLF-COD PIC 9(7).
           05 CFACD REDEFINES CLF-COD.
              10 CFMS PIC 99.
              10 CFCD PIC 9(5).
           05 DAT1.
              10 GG1 PIC 99 VALUE ZERO.
              10 MM1 PIC 99 VALUE ZERO.
              10 AA1 PIC 99 VALUE ZERO.
           05 DAT2.
              10 GG2 PIC 99 VALUE ZERO.
              10 MM2 PIC 99 VALUE ZERO.
              10 AA2 PIC 99 VALUE ZERO.
           05 DT1 PIC 9(5) COMP-3.
           05 DT2 PIC 9(5) COMP-3.
           05 DT3       PIC 9(5) COMP-3.
           05 FLGPC     PIC 9    VALUE ZERO.
           05 DTMOV     PIC 9(5) VALUE ZERO.
      **** rel 6.3
           05 DTDOC     PIC 9(5) VALUE ZERO.
      ************
           05 FLGIS-02  PIC 9    VALUE ZERO.
           05 ALA1.
              10 FILLER PIC X VALUE SPACE.
              10 ALA2 PIC X(35) VALUE SPACE.
           05 ALA3 REDEFINES ALA1.
              10 ELX OCCURS 18 PIC XX.
           05 TOTIV    PIC S9(11)V99 VALUE ZERO.
           05 TOTIVC   PIC S9(11)V99  VALUE ZERO.
           05 TOTIVD   PIC S9(11)V99  VALUE ZERO.
           05 TOTIND0  PIC S9(11)V99  VALUE ZERO.
           05 TOTIVCP  PIC S9(11)V99  VALUE ZERO.
           05 TOTALE   PIC  9(11)V99 VALUE ZERO.
           05 IMPOSTA  PIC S9(11)V99 VALUE ZERO.
           05 MATRICE.
      **** rel 7.1
      *       10 CDIVA  PIC 9(3)  OCCURS 50.
      *       10 ACQVE PIC S9(11)V99 OCCURS 50.
              10 CDIVA  PIC 9(3)  OCCURS 999.
              10 ACQVE PIC S9(11)V99 OCCURS 999.
      ************
           05 T25PER   PIC 9        VALUE ZERO.
           05 T25ESE   PIC 9        VALUE ZERO.
           05 T25TSR   PIC 9        VALUE ZERO.
           05 T25ATT   PIC 9        VALUE ZERO.
           05 T25PRI   PIC 9(3)V99  VALUE ZERO.
           05 T25IND   PIC 9(7)     VALUE ZERO.
           05 DTPK     PIC 9(5) COMP-3 VALUE ZERO.
           05 DTK      PIC 9(5) COMP-3 VALUE ZERO.
           05 CIVAV    PIC 9(7) COMP-3 VALUE ZERO.
           05 MESI.
              10 FILLER PIC X(9)    VALUE 'GENNAIO'.
              10 FILLER PIC X(9)    VALUE 'FEBBRAIO'.
              10 FILLER PIC X(9)    VALUE 'MARZO'.
              10 FILLER PIC X(9)    VALUE 'APRILE'.
              10 FILLER PIC X(9)    VALUE 'MAGGIO'.
              10 FILLER PIC X(9)    VALUE 'GIUGNO'.
              10 FILLER PIC X(9)    VALUE 'LUGLIO'.
              10 FILLER PIC X(9)    VALUE 'AGOSTO'.
              10 FILLER PIC X(9)    VALUE 'SETTEMBRE'.
              10 FILLER PIC X(9)    VALUE 'OTTOBRE'.
              10 FILLER PIC X(9)    VALUE 'NOVEMBRE'.
              10 FILLER PIC X(9)    VALUE 'DICEMBRE'.
           05 MESE REDEFINES MESI PIC X(9) OCCURS 12.
           05 TRIME.
              10 FILLER PIC X(12)   VALUE '1o TRIMESTRE'.
              10 FILLER PIC X(12)   VALUE '2o TRIMESTRE'.
              10 FILLER PIC X(12)   VALUE '3o TRIMESTRE'.
              10 FILLER PIC X(12)   VALUE '4o TRIMESTRE'.
           05 TRIM REDEFINES TRIME PIC X(12) OCCURS 4.
           05 NMES     PIC 99       VALUE ZERO.
           05 ANNO     PIC 99       VALUE ZERO.
      **** NT 7.1
      *    05 K1       PIC 99       VALUE ZERO.
      *    05 K2       PIC 99       VALUE ZERO.
      *    05 K3       PIC 99       VALUE ZERO.
      *    05 K4       PIC 99       VALUE ZERO.
           05 K1       PIC 9(4)     VALUE ZERO.
           05 K2       PIC 9(4)     VALUE ZERO.
           05 K3       PIC 9(4)     VALUE ZERO.
           05 K4       PIC 9(4)     VALUE ZERO.
      **********
           05 DESCOR PIC X(38) VALUE 
           '   ____ C O R R I S P E T T I V I ___'.
           05 TESCOR PIC X(30) VALUE 
           '   IMP.LORDO   IMPONIBILE'.
           05 TESCOR1 PIC X(8) VALUE 'IMPOSTA'.
           05 CONTA PIC 9(7) VALUE ZERO.
           05 SW       PIC 9 VALUE ZERO.
           05 FTRI     PIC 9 VALUE ZERO.
           05 COMCOD   PIC 9(7) COMP-3 VALUE ZERO.
           05 COMNPRGI PIC 9(5) COMP-3 VALUE ZERO.
           05 COMIVA   PIC 999    VALUE ZERO.
           05 COMIMP   PIC S9(11)V99 VALUE ZERO.
           05 COMIMPO  PIC S9(11)V99 VALUE ZERO.
           05 COMIVN   PIC S9(11)V99 VALUE ZERO.
           05 COMCLF   PIC 9      VALUE ZERO.
           05 COMTIP   PIC 9      VALUE ZERO.
           05 COMCDV   PIC 999    VALUE ZERO.
           05 COMVAL   PIC S9(11)V99 VALUE ZERO.
           05 TOTVAL   PIC S9(11)V99 VALUE ZERO.
           05 TOTIMP   PIC S9(11)V99 VALUE ZERO.
           05 TOTAIVA  PIC S9(11)V99 VALUE ZERO.
           05 TOTDOC   PIC S9(13)V99 VALUE ZERO.
      **** rel 7.1
      *    05 MATCON   OCCURS 50.
           05 MATCON   OCCURS 999.
      ************
              10 CODIVA PIC 9(3).
              10 IMPCON PIC S9(11)V99.
              10 IVACON PIC S9(11)V99.
              10 INDCON PIC S9(11)V99.
      **** NT 7.1
      *    05 K5        PIC 99.
           05 K5        PIC 9(4).
      **********
           05 TTIMP     PIC S9(11)V99 VALUE ZERO.
           05 TTIVA     PIC S9(11)V99 VALUE ZERO.
           05 TTIND     PIC S9(11)V99 VALUE ZERO.
           05 EARROT    PIC 9V99 VALUE 0,50.
           05 NETCRE   PIC S9(11)V99   VALUE ZERO.
           05 COMPE    PIC S9(11)V99   VALUE ZERO.
           05 TOTIVCN  PIC S9(12)V99   VALUE ZERO.
           05 NTRIME   PIC 9           VALUE ZERO.
           05 SAV-ACREDI PIC S9(11)V99.
           05 SAV-DAVERS PIC S9(11)V99.
      **** rel 7.2
           05 K6        PIC 9(4).
           05 W-IND     PIC 9(1).
      ************
      **** rel 6.3
           05 ANNELA   PIC 9(4).
           05 FLGST    PIC 9.
      * incasso fatture in sospeso dell'anno
      **** rel 7.1
      *    05 FSA-MATCON   OCCURS 50.
           05 FSA-MATCON   OCCURS 999.
      ************
              10 FSA-CODIVA PIC 9(3).
              10 FSA-IMPCON PIC S9(11)V99.
              10 FSA-IVACON PIC S9(11)V99.
              10 FSA-INDCON PIC S9(11)V99.
      * incasso fatture in sospeso dell'anno precedente
      **** rel 7.1
      *    05 FSP-MATCON   OCCURS 50.
           05 FSP-MATCON   OCCURS 999.
      ************
              10 FSP-CODIVA PIC 9(3).
              10 FSP-IMPCON PIC S9(11)V99.
              10 FSP-IVACON PIC S9(11)V99.
              10 FSP-INDCON PIC S9(11)V99.
      * incasso fatture in sospeso da incassare
      **** rel 7.1
      *    05 FSI-MATCON   OCCURS 50.
           05 FSI-MATCON   OCCURS 999.
      ************
              10 FSI-CODIVA PIC 9(3).
              10 FSI-IMPCON PIC S9(11)V99.
              10 FSI-IVACON PIC S9(11)V99.
              10 FSI-INDCON PIC S9(11)V99.
      **** rel 7.2
      * incasso fatture in sospeso dell'anno
           05 SIDICUI      PIC 9.
           05 SFSA-MATCON   OCCURS 999.
              10 SFSA-CODIVA PIC 9(3).
              10 SFSA-IMPCON PIC S9(11)V99.
              10 SFSA-IVACON PIC S9(11)V99.
              10 SFSA-INDCON PIC S9(11)V99.
      * incasso fatture in sospeso dell'anno precedente
           05 SFSP-MATCON   OCCURS 999.
              10 SFSP-CODIVA PIC 9(3).
              10 SFSP-IMPCON PIC S9(11)V99.
              10 SFSP-IVACON PIC S9(11)V99.
              10 SFSP-INDCON PIC S9(11)V99.
      * incasso fatture in sospeso da incassare
           05 SFSI-MATCON   OCCURS 999.
              10 SFSI-CODIVA PIC 9(3).
              10 SFSI-IMPCON PIC S9(11)V99.
              10 SFSI-IVACON PIC S9(11)V99.
              10 SFSI-INDCON PIC S9(11)V99.
      * movimenti iva del mese
           05 MDM-MATCON   OCCURS 999.
              10 MDM-CODIVA PIC 9(3).
              10 MDM-IMPCON PIC S9(11)V99.
              10 MDM-IVACON PIC S9(11)V99.
              10 MDM-INDCON PIC S9(11)V99.
      * movimenti iva "mese corrente"
           05 MCO-MATCON   OCCURS 999.
              10 MCO-CODIVA PIC 9(3).
              10 MCO-IMPCON PIC S9(11)V99.
              10 MCO-IVACON PIC S9(11)V99.
              10 MCO-INDCON PIC S9(11)V99.
      * movimenti iva "mese precedente"
           05 MPR-MATCON   OCCURS 999.
              10 MPR-CODIVA PIC 9(3).
              10 MPR-IMPCON PIC S9(11)V99.
              10 MPR-IVACON PIC S9(11)V99.
              10 MPR-INDCON PIC S9(11)V99.
      ************
           05 SAV-TPLIQ  PIC 9.
           05 SAV-FLTOT  PIC 9.
      **** rel 7.2
           05 SAVPIVA    PIC X(20).
           05 SAVCFISC   PIC X(20).
           05 W-IVA-FIS  PIC X(40).
      **********
      ************
      **** rel 7.1
           05 DIFFDATE PIC 9(5) VALUE ZERO.
      ************
       01  VTLIQ.
           05 DTLIQ PIC   9(5) OCCURS 12.
           05 IMLIQ PIC S9(11)V99 OCCURS 12.
       01  VTRIM.
           05 IMRIB PIC S9(11)V99 OCCURS 3.

           COPY 'vcon140.cpy'.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
           05 IF-FL        PIC 9.
           05 IF-LMOD      PIC 99.
      **** rel 6.3
           05 IF-CHIUDI    PIC 9.
      ************
           COPY 'grirpt-l'.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
      * data
           05 IF-DTLIQ     PIC 9(6).
           05 IF-CATT      PIC X.
           05 IF-CATT-D    PIC X(24).
           05 IF-TPREG     PIC 9.
           05 IF-FLPRO     PIC 9.
      * data
           05 IF-DATA-1    PIC 9(6).
      * data
           05 IF-DATA-2    PIC 9(6).
           05 IF-FLTOT     PIC 9.
           05 IF-TPLIQ     PIC 9.
      * data
           05 IF-DTRIN     PIC 9(6).
           05 IF-UNAS      PIC 9(5).
      * data
           05 IF-DTATT     PIC 9(6).
           05 IF-UNAT      PIC 9(5).
      *
           05 IF-PER-D     PIC X(15).
      * data
           05 IF-DTMOV-1   PIC 9(6).
      * data
           05 IF-DTMOV-2   PIC 9(6).
           05 IF-IVEN      PIC S9(11)V99.
           05 IF-IACQ      PIC S9(11)V99.
           05 IF-ICOR      PIC S9(11)V99.
           05 IF-ULTDE     PIC S9(11)V99.
           05 IF-DPREC     PIC S9(11)V99.
           05 IF-CPREC     PIC S9(11)V99.
           05 IF-PRORA     PIC S9(11)V99.
           05 IF-IMDE      PIC S9(11)V99.
           05 IF-IMCR      PIC S9(11)V99.
           05 IF-IMIN      PIC S9(11)V99.
           05 IF-ACCV      PIC S9(11)V99.
      * data
           05 IF-DTVE      PIC 9(6).
           05 IF-CDBA      PIC X(11).
           05 IF-RIMB      PIC S9(11)V99.
           05 IF-TOTCRE    PIC S9(11)V99.
      * data
           05 IF-DTCON     PIC 9(6).
           05 IF-DSAGG     PIC X(26).
      * flag hide-show interfaccia
           05 IF-HS-ULTRIN PIC 9.
           05 IF-HS-W-DB1  PIC 9.
           05 IF-HS-ACCV   PIC 9.
           05 IF-HS-PER-D  PIC 9.
           05 IF-HS-DTVE   PIC 9.
           05 IF-HS-RIMB   PIC 9.
           05 IF-HS-145    PIC 9.
      *------------------------------------------------------------------
      * note dei flags hide-show
      * IF-HS-ULTRIN: visualizzazione dati ultima rinumerazione
      *               campi IF-DTRIN e IF-UNAS
      *               0=no  1=si
      * IF-HS-W-DB1 : visualizzazione finestra prospetto (W-DB1)
      *               liquidazione IVA
      *               0=no  1=si
      * IF-HS-ACCV  : abilitazione campo IF-ACCV su W-DB1
      *               0=no  1=si
      * IF-HS-PER-D : abilitazione campo IF-PER-D su W-DB1
      *               0=no  1=si
      * IF-HS-DTVE  : abilitazione campi IF-DTVE e IF-CDBA su W-DB1
      *               0=no  1=si
      * IF-HS-RIMB  : abilitazione campi IF-RIMB e IF-TOTCRE su W-DB1
      *               0=no  1=si
      * IF-HS-145   : richiesta dati per vcon145
      *               (l'interfaccia lo testera' dopo la 'R')
      *               0=no    
      *               1=si   l'interfaccia chiedera' IF-DTCON e IF-DSAGG
      *                      e lancera' la funzione 'S'.
      *------------------------------------------------------------------
      *
           05 IF-NMESE    PIC 99.
           05 IF-HS-RIMBO PIC 9.
           05 IF-DAVERS   PIC S9(11)V99.
           05 IF-ACREDI   PIC S9(11)V99.
           05 IF-VP7D     PIC S9(11)V99.
           05 IF-VP7C     PIC S9(11)V99.
           05 IF-VP8      PIC S9(11)V99.
           05 IF-VP9      PIC S9(11)V99.
           05 IF-VP11     PIC S9(11)V99.
           05 IF-VP12D    PIC S9(11)V99.
           05 IF-VP12C    PIC S9(11)V99.
           05 IF-VP13     PIC S9(11)V99.
           05 IF-VP19R    PIC S9(11)V99.
           05 IF-VP19C    PIC S9(11)V99.
           05 IF-FLGERR   PIC 9.
           05 IF-NBOL      PIC 9.
           05 IF-NUM-1     PIC 9(5).
           05 IF-ANNO      PIC 9(4).
           05 IF-PIEDE-1   PIC X(60).
           05 IF-PIEDE-2   PIC X(60).
      **** rel 6.3
           05 IF-INCSOS    PIC 9.
      ************
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclmov'.
           COPY 'dclmvx'.
           COPY 'dclmmo'.
           COPY 'dclmol'.
           COPY 'dclivt'.
           COPY 'dcliva'.
           COPY 'dcltab'.
           COPY 'dcl142'.
           COPY 'dcllav'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' OR
                    'w' GO TO F-WALIDA.
           IF FUN = 'M' PERFORM VISIVA THRU EX-VISIVA    
                        GO TO FINE.
           IF FUN = 'R' OR
      **** rel 6.3
                    'r' OR
      ************
                    'S' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        IF RPT-SS-FUN NOT = ZERO
                           GO TO ESCI
                        ELSE
                           GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vcon140: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE MOVIME.
           CLOSE MOVMXX.
           CLOSE MOVMOL.
           CLOSE MOVOXX.
           CLOSE TOTIVA.
           CLOSE ANACLF.
           CLOSE WDSLAV.
      *
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN OUTPUT WDS142.
           CLOSE WDS142.
      *
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'grimover'.
           COPY 'grimoler'.
           COPY 'grimvxer'.
           COPY 'grimmoer'.
           COPY 'griivter'.
           COPY 'griivaer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
           COPY 'grirpt'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O   WDSLAV.
      *
           IF IF-FL = ZERO MOVE 'anaazi' TO ID-AZI
                           MOVE 'tabell' TO ID-TAB
                           MOVE 'anaclf' TO ID-CLF
                           MOVE 'totiva' TO ID-IVA.
           IF IF-FL = 1 MOVE 'anazol' TO ID-AZI
                        MOVE 'tabold' TO ID-TAB
                        MOVE 'anacfx' TO ID-CLF
                        MOVE 'tivaol' TO ID-IVA.
      *
           OPEN INPUT ANACLF.
           OPEN INPUT ANAAZI.
           OPEN INPUT MOVIME.
           OPEN INPUT MOVMXX.
           OPEN INPUT MOVMOL.
           OPEN INPUT MOVOXX.
           OPEN INPUT MOVIVT.
           OPEN  I-O  TOTIVA.
           OPEN  I-O  TABELL.
           OPEN  I-O  WDSLAV.
      *
      **** rel 6.3
      *    PERFORM RPT-INI.
           IF IF-CHIUDI NOT = 9 PERFORM RPT-INI.
      ************
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
      **** rel 6.3
           IF IF-CHIUDI = 9
              MOVE IF-DATA-2 TO GGMMAA
              MOVE 1 TO TIPOP1
              CALL 'rdata' USING PARCDT
              ADD 1 TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GGMMAA TO IF-DATA-1
              MOVE ZERO TO IF-DATA-2
              MOVE SAV-TPLIQ TO IF-TPLIQ
              MOVE SAV-FLTOT TO IF-FLTOT
              GO TO NO-INI.
      ************
           MOVE ZERO TO IF-REC.
           MOVE ZERO TO IF-IVEN
                        IF-IACQ
                        IF-ICOR
                        IF-ULTDE
                        IF-DPREC
                        IF-CPREC
                        IF-PRORA
                        IF-IMDE
                        IF-IMCR
                        IF-IMIN
                        IF-ACCV
                        IF-RIMB
                        IF-TOTCRE.
           MOVE SPACE TO IF-AZI-D
                         IF-CATT-D
                         IF-PER-D
                         IF-CDBA
                         IF-DSAGG.
      **** rel 6.3
       NO-INI.
      ************
      * azzeramento flags hide-show interfaccia
           MOVE ZERO TO IF-HS-ULTRIN
                        IF-HS-W-DB1
                        IF-HS-ACCV
                        IF-HS-PER-D
                        IF-HS-DTVE
                        IF-HS-RIMB
                        IF-HS-145.
      *
           MOVE ZERO TO IF-NMESE
                        IF-HS-RIMBO
                        IF-DAVERS
                        IF-ACREDI
                        IF-VP7D
                        IF-VP7C
                        IF-VP8
                        IF-VP9
                        IF-VP11
                        IF-VP12D
                        IF-VP12C
                        IF-VP13
                        IF-VP19R
                        IF-VP19C
                        IF-FLGERR.
           MOVE ZERO TO COMPE.
      *
      **** rel 6.3
      *    MOVE '0' TO IF-CATT.
      *    MOVE 1   TO IF-TPREG.
           IF IF-CHIUDI NOT = 9
              MOVE '0' TO IF-CATT
              MOVE 1   TO IF-TPREG.
      ************
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           MOVE AZI-RGSOC TO IF-AZI-D.
      *
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO INI-CAMPI-20.
       INI-CAMPI-10.
           READ WDSLAV NEXT AT END GO TO INI-CAMPI-20.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO INI-CAMPI-10.
           DELETE WDSLAV.
           GO TO INI-CAMPI-10.
       INI-CAMPI-20.
           MOVE ZERO TO XCRR.
       ACCTB.
           MOVE KAZ-COD TO IV-CDAZ.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-ESE TO T25ESE.
           IF IF-FL = 1 AND T25ESE = 1
              CLOSE TABELL TOTIVA ANAAZI
              MOVE 'anazol' TO ID-AZI
              MOVE 'tabold' TO ID-TAB
              MOVE 'tivaol' TO ID-IVA
              OPEN INPUT ANAAZI
              OPEN  I-O  TABELL
              OPEN  I-O  TOTIVA.
       LPAZI.
           MOVE KAZ-COD TO IV-CDAZ.
           MOVE AZI-FLGIS TO FLGIS.
           MOVE 25        TO T25-TIP.
           MOVE KAZ-COD   TO T25-COD.
           MOVE '0'       TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-TSR TO T25TSR.
           MOVE T25-ESE TO T25ESE.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           IF AZI-DTAPE = ZERO 
                 MOVE 'Manca data apertura esercizio' TO MESS
                 GO TO ERRIO.
           MOVE AZI-DTAPE TO DTAPE.
           IF T25ESE = 1
              MOVE AZI-DTAPE TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE 1 TO GG9 MM9
              MOVE 1 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF SWRET1 = 1
                 PERFORM ERR-DATA
                 GO TO ERRIO 
              ELSE
                 MOVE AAGGG TO DTAPE.
           MOVE DTAPE TO IV-DTAPE.
           IF NOT (IF-FL = 1 AND T25ESE = 1) GO TO LPAZ0.
           CLOSE ANAAZI TABELL TOTIVA.
           MOVE 'anaazi' TO ID-AZI.
           MOVE 'tabell' TO ID-TAB.
           MOVE 'totiva' TO ID-IVA.
           OPEN INPUT ANAAZI.
           OPEN  I-O  TOTIVA.
           OPEN  I-O  TABELL.
       LPAZ0.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '3'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE ZERO TO K1.
       LPAZ1.
           ADD 1 TO K1.
           MOVE T25-DT3(K1) TO DTLIQ(K1).
           MOVE T25-VE3(K1) TO IMLIQ(K1).
           IF K1 < 7 GO TO LPAZ1.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '4'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-VE4(6) TO IF-ACCV.
           MOVE ZERO TO K2.
       LPAZ2.
           ADD 1 TO K1 K2.
           MOVE T25-DT4(K2) TO DTLIQ(K1).
           MOVE T25-VE4(K2) TO IMLIQ(K1).
           IF K2 < 5 GO TO LPAZ2.
           MOVE '5' TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE ZERO TO K1.
       LPAZ3.
           ADD 1 TO K1.
           MOVE T25-RIB(K1) TO IMRIB(K1).
           IF K1 < 3 GO TO LPAZ3.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-ATT TO T25ATT.
           MOVE T25-PRI TO T25PRI.
           MOVE T25-IND TO T25IND.
           MOVE T25-DTR TO DTK AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTRIN DTRIN.
           MOVE T25-UNR TO IF-UNAS IF-UNAT UNAS.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-TSR TO T25TSR.
           MOVE T25-ESE TO T25ESE.
           MOVE T25-PER TO T25PER.
           MOVE T25-DUP TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTLIQ.
           IF T25-DUP = ZERO
              MOVE IV-DTAPE TO AAGGG
           ELSE
              MOVE T25-DUP TO AAGGG
              ADD 1 TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
      **** rel 6.3
      *    MOVE GGMMAA TO IF-DATA-1.
           IF IF-CHIUDI NOT = 9 MOVE GGMMAA TO IF-DATA-1.
      ************
           MOVE ZERO TO IF-NBOL
                        IF-NUM-1
                        IF-ANNO.
           MOVE SPACE TO IF-PIEDE-1
                         IF-PIEDE-2.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
           MOVE ZERO TO SW-BGB.
           IF FUN = 'w' GO TO V-DATI-DB2.
      *
       V-CATT.
           MOVE 'IF-CATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CATT. 
           IF IF-CATT NOT NUMERIC OR IF-CATT > '8' 
              PERFORM ERR-DINV
              GO TO V-ERROR.
           IF IF-CATT = '0'
              MOVE AZI-DATT TO IF-CATT-D
              MOVE DTRIN    TO IF-DTRIN
              MOVE UNAS     TO IF-UNAS IF-UNAT
              GO TO E-CATT.
      *
           MOVE 35      TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE IF-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
           READ TABELL INTO REKT35 INVALID KEY PERFORM ERR-CINE
                                               GO TO V-ERROR.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT35.
           MOVE T35-DATT TO IF-CATT-D.
           MOVE T35-DTR  TO AAGGG DTK.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA  TO IF-DTRIN.
           MOVE T35-UNR TO IF-UNAS IF-UNAT.
       E-CATT. 
      *
       V-TPREG.
           MOVE 'IF-TPREG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPREG.
           IF NOT (IF-TPREG = 1 OR 2 OR 3)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF IF-TPREG = 1
              MOVE ZERO TO IF-FLPRO
              MOVE ZERO TO IF-TPLIQ.
       E-TPREG.
      *
       V-FLPRO.
           MOVE 'IF-FLPRO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLPRO.
           IF IF-FLPRO = 1 AND IF-TPREG = 1
              MOVE ZERO TO IF-FLPRO
              MOVE 'Selezione non ammessa, adeguata' TO MESS
              GO TO V-ERROR.
           IF IF-FLPRO = ZERO MOVE ZERO TO IF-TPLIQ.
       E-FLPRO.
      *
       V-DATA-1.
           MOVE 'IF-DATA-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-1.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DT1.
      **** rel 6.3
           MOVE AA4 TO ANNELA.
      ************
           IF DT1 < IV-DTAPE
              MOVE 'Data anteriore a quella di apertura' TO MESS
              GO TO V-ERROR.
           IF FUN NOT = 'W' GO TO E-DATA-1.
           CALL 'vrdtbigb' USING DTBIG.
           IF DT1 > DTBIG GO TO E-DATA-1.
           MOVE 1 TO SW-BGB.
           MOVE 'Il periodo selezionato riguarda'      TO F-MES1.
           MOVE 'le transazioni fatte in Lire.'        TO F-MES2.
           MOVE 'L''operazione deve essere effettuata' TO F-MES3.
           MOVE 'da Primula versione Euro1.'           TO F-MES4.
           MOVE 'Vuoi proseguire ugualmente ?'         TO F-MES5.
           MOVE 5 TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP NOT = 'S' 
              MOVE 'Operazione non eseguita ' TO MESS
              GO TO V-ERROR.
       E-DATA-1.
      *
       V-DATA-2.
           MOVE 'IF-DATA-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DATA-2.
           MOVE 1 TO TIPOP1.
           MOVE IF-DATA-2 TO GGMMAA DAT2.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO DT2.
           IF DT2 < DT1
              PERFORM ERR-DINC
              GO TO V-ERROR.
           IF IF-TPREG = 1 OR IF-FLPRO = ZERO GO E-DATA-2.
           IF (DT2 > T25-DUP) AND (DT1 NOT > T25-DUP)
              MOVE 'Date  incongruenti  rispetto a  data' TO F-MES1
              MOVE 'aggiornamento totali IVA progressivi' TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
           MOVE IF-DATA-1 TO DAT1.
           MOVE IF-DATA-2 TO DAT2.
           IF AA1 NOT = AA2 
              PERFORM ERR-DINV
              GO TO V-ERROR.
           MOVE DT2 TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE 1 TO TIPOP1.
           MOVE 31 TO GG9.
       LPROS-10.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 NOT = ZERO SUBTRACT 1 FROM GG9 GO TO LPROS-10.
           MOVE AAGGG TO DT2.
           MOVE GGMMAA TO IF-DATA-2 DAT2.
           MOVE ZERO TO N.
           SUBTRACT MM1 FROM MM2 GIVING N.
           IF (T25PER = 0 AND N > 0) OR
              (T25PER > 0 AND N > 2) 
              MOVE ZERO TO N 
              MOVE 'Periodo errato' TO MESS
              GO TO V-ERROR.
           MOVE ZERO TO N.
           IF T25-PER > ZERO 
              IF NOT (MM2 = 3 OR 6 OR 9 OR 12)
              MOVE 'Periodo errato' TO MESS
              GO TO V-ERROR.
           IF DT2 > T25-DUP
              MOVE 1 TO IV-TSDAT
           ELSE
              MOVE ZERO TO IV-TSDAT.
           MOVE MM9 TO NMES.
           MOVE AA9 TO ANNO.
       E-DATA-2.
      *
       V-FLTOT.
           MOVE 'IF-FLTOT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-FLTOT.
       E-FLTOT.
      *
       V-TPLIQ.
           MOVE 'IF-TPLIQ' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPLIQ.
           IF NOT (IF-TPLIQ = ZERO OR 1 OR 2)
              PERFORM ERR-RADIO
              GO TO V-ERROR.
           IF IF-TPLIQ NOT = ZERO AND IF-TPREG = 1
              MOVE 'Stampa liquidazione su acquisti ' TO F-MES1
              MOVE '       non consentita           ' TO F-MES2
              MOVE 2 TO F-NMES
              GO TO V-ERROR.
           IF FUN NOT = 'W' GO TO E-TPLIQ.
           IF SW-BGB = ZERO GO TO E-TPLIQ.
           IF IF-TPLIQ = 2
              MOVE 1 TO IF-TPLIQ 
              MOVE 'L''aggiornamento dei totali' TO F-MES1
              MOVE 'non verra'' effettuato'      TO F-MES2
              MOVE 2 TO F-NMES
              CALL 'vrmbox' USING PARMB.
       E-TPLIQ.
      **** rel 6.3
           IF IF-CHIUDI = 9 MOVE ZERO TO IF-NBOL.
      ************
           IF FUN = 'W' GO TO END-V-DATI.
      *
      * validazione dati 2a finestra (db2)
      *
       V-DATI-DB2.
      *
       V-ACCV.
           MOVE 'IF-ACCV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ACCV.
           IF IF-HS-ACCV = ZERO
              GO TO E-ACCV.
           IF NMES NOT = 12 
              MOVE ZERO TO IF-ACCV
              GO TO E-ACCV.
           IF FUN = 'w'
              SUBTRACT IF-ACCV FROM TOTIV.
           PERFORM VISIVA THRU EX-VISIVA.
       E-ACCV.
      *
       V-DTVE.
           MOVE 'IF-DTVE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTVE.
           IF IF-HS-DTVE = ZERO
              GO TO E-DTVE.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTVE TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTVE.
      *
       V-DTCON.
           MOVE 'IF-DTCON' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTCON.
           IF IF-HS-145 = ZERO
              GO TO E-DTCON.
      * attenzione: controllo eseguito solo per chiamata diretta
           IF FUN NOT = 'V' GO TO E-DTCON.
           IF IF-DTCON = ZERO
                PERFORM ERR-ZERO
                GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE IF-DTCON TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           IF AAGGG < AZI-RVDT
              MOVE 'Data inferiore alla chiusura mensile' TO MESS
              GO TO V-ERROR.
      **** rel 6.1
           IF AAGGG < IV-DTAPE
              MOVE 'Data anteriore a quella di apertura' TO MESS
              GO TO V-ERROR.
      ************
       E-DTCON.
      *
      **** rel 6.3
       V-INCSOS.
           MOVE 'IF-INCSOS' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-INCSOS.
           IF IF-TPREG NOT = 2 AND IF-INCSOS = 1
              MOVE ZERO TO IF-INCSOS
              MOVE 'Selezione non ammessa, adeguata' TO MESS
              GO TO V-ERROR.
       E-INCSOS.
      *
      ************
       END-V-DATI.
      **** rel 7.1
      *
           IF FUN NOT = 'W'    GO TO END-V-DATI2.
      *
           IF IF-TPLIQ NOT = 2 GO TO END-V-DATI2.
      *
           IF T25ESE NOT = ZERO 
              MOVE DTAPE TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE 31 TO GG9
              MOVE 12 TO MM9
              CALL 'rdata' USING PARCDT
              MOVE AAGGG TO DIFFDATE
              IF DT2 > DIFFDATE
                 MOVE 'W' TO MB-TIPO
                 MOVE 'Totali IVA e Aggiornamento' TO MB-TITOLO
                 MOVE 'Data selezionata maggiore della data' TO F-MES1
                 MOVE 'fine esercizio.' TO F-MES2
                 MOVE 2 TO F-NMES
                 CALL 'vrmbox' USING PARMB
              END-IF
           ELSE
              IF IF-FL NOT = ZERO
                 MOVE 'W' TO MB-TIPO
                 MOVE 'Totali IVA e Aggiornamento' TO MB-TITOLO
                 MOVE 'Questa procedura, se eseguita da vecchio' 
                    TO F-MES1
                 MOVE 'esercizio potrebbe aggiornare in modo' 
                    TO F-MES2
                 MOVE 'errato i Totali IVA.' TO F-MES3
                 MOVE 3 TO F-NMES
                 CALL 'vrmbox' USING PARMB.
      *    
       END-V-DATI2.
      ************
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
           COPY 'grirpt-s'.
      *
      **** rel 6.1
           IF FUN = 'S' GO TO RUN-RIENTRO.
      ************
      **** rel 6.3
           MOVE 1 TO FLGST.
           IF IF-INCSOS = 1 MOVE ZERO TO FLGST
                            MOVE 1    TO IF-FLTOT.
      ************
      **** rel 6.3
           IF FUN = 'r'
              IF IF-CHIUDI = 9
                 GO TO LP-CHIUDI
              ELSE
                 GO TO EX-RUN-ELABORA.
           IF IF-CHIUDI = 9 GO TO ALTRO-RPT.
      ************
           IF RP-TRPT = ZERO 
              MOVE 'E'' possibile stampare il Report' TO F-MES1
              MOVE 'solo a carattere o visuale.'     TO F-MES2
              MOVE 'Forzato visuale.' TO F-MES3
              MOVE 3 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB
              MOVE 1 TO RP-TRPT.
      *
           IF IF-NBOL = 1
              MOVE 'PBK_ADES' TO RP-BLK
              MOVE IF-PIEDE-1 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_ACIT' TO RP-BLK
              MOVE IF-PIEDE-2 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_DPAG' TO RP-BLK
              STRING 'Anno: ' IF-ANNO
                     DELIMITED SIZE INTO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE 'PBK_NPAG' TO RP-BLK
              MOVE IF-NUM-1 TO RP-RIGA
              PERFORM RPT-INI-PIEDE
      *
              MOVE IF-ANNO  TO PANNO PANNO1
              MOVE '/'      TO PBARR PBARR1
              IF IF-ANNO = ZERO 
                 MOVE SPACE TO PANNO  PBARR 
                               PANNO1 PBARR1
              END-IF
              MOVE ZERO TO FNPG
           ELSE
              MOVE SPACE TO RTPAG
              MOVE 1 TO FNPG
              MOVE 'np' TO RP-VERM.    *> per non stampare il piede

      *
      **** rel 6.1
      *    IF FUN = 'S' GO TO RUN-RIENTRO.
      ************
      **** rel 6.3
           MOVE IF-TPLIQ TO SAV-TPLIQ.
           MOVE IF-FLTOT TO SAV-FLTOT.
      *
           MOVE ZERO TO IF-CHIUDI.
       ALTRO-RPT.
      ************
           MOVE ZERO TO IF-HS-145.
           MOVE ZERO TO TOTIMP TOTAIVA TOTDOC.
           MOVE ZERO TO TOTVAL.
      **** rel 7.2
      *    IF IF-TPREG = 1 OR 3 MOVE DT2 TO DT3
      *    ELSE COMPUTE DT3 = DT2 + 15.
           COMPUTE DT3 = DT2 + 15.
      ************
           MOVE 1  TO KTB-COD.
           MOVE 14 TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T14-FTRI TO FTRI.
           IF IF-TPREG NOT = 3 GO TO LAZ4.
           MOVE T14-CDCOR TO CIVA.
           MOVE ZERO      TO CIVSO.
           MOVE IF-CATT-D TO TSX5.
           GO TO LAZ4-1.
       LAZ4.
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF IF-TPREG = 1
              MOVE T01-CIVAQ TO CIVA
              MOVE ZERO TO CIVSO
              MOVE 'A C Q U I S T I' TO TSX2
              MOVE IF-CATT-D TO TSX3
              GO TO LAZ5.
           IF IF-TPREG = 2 
              MOVE T01-CIVAV TO CIVA CIVAV
              MOVE T01-CIVSO TO CIVSO
              MOVE 'V E N D I T E' TO TSX2
              MOVE IF-CATT-D TO TSX3.
       LAZ4-1.
      *
       LAZ5.
           MOVE AZI-RGSOC TO RAZI RAZI1.
           IF IF-TPREG = 1 OR 2
      *-- inizializza parametri per stampa a caratteri --*
              IF IF-LMOD = 12
                 MOVE 72 TO NRGF
                 MOVE 64 TO NRGL
              ELSE
                 MOVE 66 TO NRGF
                 MOVE 58 TO NRGL
              END-IF
              MOVE C-TTS   TO RTTS
              MOVE 2       TO NINT
              MOVE C-TINT-1 TO XTINT(1)
              MOVE C-TINT-2 TO XTINT(2)
      *--------------------------------------------------*
      *-- inizializza parametri per stampa report --*
              MOVE KAZ-COD TO RP-CAZI
              MOVE SPACE TO RP-TIT1
              IF IF-TPREG = 1
                 STRING 'REGISTRO IVA ACQUISTI'
                        DELIMITED SIZE INTO RP-TIT1
              ELSE
                 STRING 'REGISTRO IVA VENDITE'
                        DELIMITED SIZE INTO RP-TIT1
              END-IF
      *
              MOVE SPACE TO RP-TIT2
              STRING TSX3 DELIMITED SIZE INTO RP-TIT2
      *
              PERFORM RPT-RIG1-INTC
      *
      *       MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
           ELSE
      *-- inizializza parametri per stampa a caratteri --*
              IF IF-LMOD = 12
                 MOVE 72 TO NRGF
                 MOVE 64 TO NRGL
              ELSE
                 MOVE 66 TO NRGF
                 MOVE 58 TO NRGL
              END-IF
              MOVE C-TTSB  TO RTTS
              MOVE 3       TO NINT
              MOVE C-TINTB-1 TO XTINT(1)
              MOVE C-TINTB-2 TO XTINT(2)
              MOVE C-TINTB-3 TO XTINT(3)
      *--------------------------------------------------*
      *-- inizializza parametri per stampa report --*
              MOVE KAZ-COD TO RP-CAZI
              MOVE SPACE TO RP-TIT1
              STRING 'REGISTRO CORRISPETTIVI ' TSX5 
                     DELIMITED SIZE INTO RP-TIT1
      *
              PERFORM RPT-RIG1B-INTC
      *
      *       MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
           END-IF
      *
           MOVE KAZ-COD TO KMO-AZI.
           MOVE CIVA    TO KMO-CON.
           MOVE DT1     TO KMO-DAT.
           MOVE ZERO    TO KMO-NUM.
           START MOVOXX KEY NOT < KEYMO INVALID GO TO LAZ10.
       LOP5.
           READ MOVOXX NEXT INTO REKMOV AT END GO TO LAZ10.
           IF SF-MMO = '9D' OR '9A' OR '35' GO TO LOP5.
           IF KMO-AZI      > KAZ-COD GO TO LAZ10.
           IF KMO-CON      > CIVA    GO TO LAZ10.
           IF KMO-DAT      < DT1     GO TO LOP5.
           IF KMO-DAT      > DT3     GO TO LAZ10.
           IF KMO-DAT      > DT2
              IF MOV-FLGPC = ZERO    GO TO LOP5.
           IF MOV-CATT NOT = IF-CATT GO TO LOP5.
           IF MOV-FLAG     = 1       GO TO LOP5.
           IF IF-TPREG NOT = 2       GO TO LOP5-10.
           IF CIVA     NOT = CIVAV   GO TO LOP5-10.
           IF T25PER   NOT = 2       GO TO LOP5-10.
      *
           COPY 'grirpt-r'. 
      *
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-TSOPE = 7 GO TO LOP5-10.
           GO TO LOP5.
       LOP5-10.
           PERFORM AGGLAV THRU EX-AGGLAV.
           GO TO LOP5.
       LAZ10.
           MOVE KAZ-COD TO KML-AZI.
           MOVE CIVA    TO KML-CON.
           MOVE DT1     TO KML-DAT.
           MOVE ZERO    TO KML-NUM.
           START MOVMOL KEY NOT < KEYML INVALID GO TO LAZ20.
       LOP10.
           READ MOVMOL NEXT INTO REKMOV AT END GO TO LAZ20.
           IF SF-MOL = '9D' OR '9A' OR '35' GO TO LOP10.
           IF KML-AZI      > KAZ-COD GO TO LAZ20.
           IF KML-CON      > CIVA    GO TO LAZ20.
           IF KML-DAT      < DT1     GO TO LOP10.
           IF KML-DAT      > DT3     GO TO LAZ20.
           IF KML-DAT      > DT2
              IF MOV-FLGPC = ZERO    GO TO LOP10.
           IF MOV-CATT NOT = IF-CATT GO TO LOP10.
           IF MOV-FLAG     = 1       GO TO LOP10.
           IF IF-TPREG NOT = 2       GO TO LOP10-10.
           IF CIVA     NOT = CIVAV   GO TO LOP10-10.
           IF T25PER   NOT = 2       GO TO LOP10-10.
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-TSOPE = 7 GO TO LOP10-10.
           GO TO LOP10.
       LOP10-10.
           PERFORM AGGLAV THRU EX-AGGLAV.
           GO TO LOP10.
       LAZ20.
           MOVE KAZ-COD TO KMX-AZI.
           MOVE CIVA    TO KMX-CON.
           MOVE DT1     TO KMX-DAT.
           MOVE ZERO    TO KMX-NUM.
           START MOVMXX KEY NOT < KEYMX INVALID GO TO LAZ30.
       LOP20.
           READ MOVMXX NEXT INTO REKMOV AT END GO TO LAZ30.
           IF SF-MVX = '9D' OR '9A' OR '35' GO TO LOP20.
           IF KMX-AZI      > KAZ-COD GO TO LAZ30.
           IF KMX-CON      > CIVA    GO TO LAZ30.
           IF KMX-DAT      < DT1     GO TO LOP20.
           IF KMX-DAT      > DT3     GO TO LAZ30.
           IF KMX-DAT      > DT2
              IF MOV-FLGPC = ZERO    GO TO LOP20.
           IF MOV-CATT NOT = IF-CATT GO TO LOP20.
           IF MOV-FLAG     = 1       GO TO LOP20.
           IF IF-TPREG NOT = 2       GO TO LOP20-10.
           IF CIVA     NOT = CIVAV   GO TO LOP20-10.
           IF T25PER   NOT = 2       GO TO LOP20-10.
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-TSOPE = 7 GO TO LOP20-10.
           GO TO LOP20.
       LOP20-10.
           PERFORM AGGLAV THRU EX-AGGLAV.
           GO TO LOP20.
       LAZ30.
           MOVE KAZ-COD TO KMV-AZI.
           MOVE CIVA    TO KMV-CON.
           MOVE DT1     TO KMV-DAT.
           MOVE ZERO    TO KMV-NUM.
           START MOVIME KEY NOT < KEYMV INVALID GO TO ENDA.
       LOPM.
           READ MOVIME NEXT INTO REKMOV AT END GO TO ENDA.
           IF SF-MOV = '9D' OR '9A' OR '35' GO TO LOPM.
           IF KMV-AZI      > KAZ-COD GO TO ENDA.
           IF KMV-CON      > CIVA    GO TO ENDA.
           IF KMV-DAT      < DT1     GO TO LOPM.
           IF KMV-DAT      > DT3     GO TO ENDA.
           IF KMV-DAT      > DT2
              IF MOV-FLGPC = ZERO    GO TO LOPM.
           IF MOV-CATT NOT = IF-CATT GO TO LOPM.
           IF MOV-FLAG     = 1       GO TO LOPM.
           IF IF-TPREG NOT = 2       GO TO LOPM-10.
           IF CIVA     NOT = CIVAV   GO TO LOPM-10.
           IF T25PER   NOT = 2       GO TO LOPM-10.
           MOVE 3       TO KTB-TIP.
           MOVE MOV-IVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF T03-TSOPE = 7 GO TO LOPM-10.
           GO TO LOPM.
       LOPM-10.
           PERFORM AGGLAV THRU EX-AGGLAV.
           GO TO LOPM.
       ENDA.
           EXIT.
       ENDA-00.
           IF IF-TPREG NOT = 2     GO TO ENDA-10.
           IF CIVA     NOT = CIVAV GO TO ENDA-10.
           IF T25PER   NOT = 2     GO TO ENDA-10.
           MOVE KAZ-COD TO KVT-AZI.
           MOVE CIVA    TO KVT-CON.
           MOVE DT1     TO KVT-DAT.
           MOVE ZERO    TO KVT-NUM.
           START MOVIVT KEY NOT < KEYVT INVALID GO TO ENDA-10.
       LOPVT.
           READ MOVIVT NEXT INTO REKMOV AT END GO TO ENDA-10.
           IF SF-IVT = '9D' OR '9A' OR '35' GO TO LOPVT.
           IF KVT-AZI      > KAZ-COD GO TO ENDA-10.
           IF KVT-CON      > CIVA    GO TO ENDA-10.
           IF KVT-DAT      < DT1     GO TO LOPVT.
           IF KVT-DAT      > DT3     GO TO ENDA-10.
           IF KVT-DAT      > DT2
              IF MOV-FLGPC = ZERO    GO TO LOPVT.
           IF MOV-CATT NOT = IF-CATT GO TO LOPVT.
           IF MOV-FLAG     = 1       GO TO LOPVT.
           PERFORM AGGLAV THRU EX-AGGLAV.
           GO TO LOPVT.
       ENDA-10.
           IF CIVA NOT = CIVSO
              IF IF-TPREG = 2 AND FLGIS = 2
                 MOVE CIVSO TO CIVA
                 PERFORM LAZ5 THRU ENDA.
           IF CONTA = ZERO MOVE ZERO TO IF-FLTOT.
           IF CONTA = ZERO AND IF-TPLIQ = ZERO GO TO ENDST.
           IF CONTA = ZERO GO TO ECH9.
           MOVE ZERO TO COMCOD
                        COMNPRGI
                        SW
                        K5
                        DTCOM
                        COMCAU
                        DATAS
                        NUMAX
                        COMODO
                        COMIMP
                        COMIMPO
                        COMIVN
                        COMIVA
                        COMVAL
                        COMTIP
                        COMCDV
                        COMCLF.
           MOVE 99999 TO NUMIN.
       AZZ.
           ADD 1 TO K5.
      **** NT 7.1
      *    IF K5 > 50 GO TO AZZ1.
           IF K5 > 999 GO TO AZZ1.
      **********
           MOVE ZERO TO CODIVA(K5) IVACON(K5)
                        IMPCON(K5) INDCON(K5).
      **** rel 6.3
           MOVE ZERO TO FSA-CODIVA(K5) FSA-IVACON(K5)
                        FSA-IMPCON(K5) FSA-INDCON(K5).
           MOVE ZERO TO FSP-CODIVA(K5) FSP-IVACON(K5)
                        FSP-IMPCON(K5) FSP-INDCON(K5).
           MOVE ZERO TO FSI-CODIVA(K5) FSI-IVACON(K5)
                        FSI-IMPCON(K5) FSI-INDCON(K5).
      ************
      **** rel 7.2
           MOVE ZERO TO SFSA-CODIVA(K5) SFSA-IVACON(K5)
                        SFSA-IMPCON(K5) SFSA-INDCON(K5).
           MOVE ZERO TO SFSP-CODIVA(K5) SFSP-IVACON(K5)
                        SFSP-IMPCON(K5) SFSP-INDCON(K5).
           MOVE ZERO TO SFSI-CODIVA(K5) SFSI-IVACON(K5)
                        SFSI-IMPCON(K5) SFSI-INDCON(K5).
      *
           MOVE ZERO TO MCO-CODIVA(K5) MCO-IVACON(K5)
                        MCO-IMPCON(K5) MCO-INDCON(K5).
           MOVE ZERO TO MPR-CODIVA(K5) MPR-IVACON(K5)
                        MPR-IMPCON(K5) MPR-INDCON(K5).
           MOVE ZERO TO MDM-CODIVA(K5) MDM-IVACON(K5)
                        MDM-IMPCON(K5) MDM-INDCON(K5).
      ************
           GO TO AZZ.
       AZZ1.
           MOVE LOW-VALUE TO KEYLV.
           START WDSLAV KEY > KEYLV INVALID GO TO ENDB.
       LOPL.
           READ WDSLAV NEXT AT END MOVE 1 TO SW
                                   GO TO RLIB2.
           IF SF-LAV = '9D' OR '9A' OR '35' GO TO LOPL.
           MOVE LAV-RMOV TO REKMOV.
       LOPL-20.
           IF IF-TPREG = 3 GO TO LOPL0.
           IF IF-TPREG > 1    OR
              T25TSR   = ZERO OR
              DTK  NOT < DT2  GO TO LOP0.
           IF KLV-NPRGI > IF-UNAT MOVE KLV-NPRGI TO IF-UNAT.
       LOP0.
           IF DTCOM = ZERO MOVE MOV-DAT TO DTCOM.
           IF COMNPRGI = ZERO MOVE KLV-NPRGI TO COMNPRGI.
           IF DTCOM NOT = MOV-DAT
              MOVE ZERO TO COMNPRGI
              MOVE MOV-DAT TO DTCOM.
           IF COMNPRGI = KLV-NPRGI
              IF (COMCOD = ZERO OR COMCOD = KLV-CDCLI) AND
                 (COMCAU = ZERO OR COMCAU = MOV-CAUS)  GO TO LOPL0.
           MOVE 2 TO SW GO TO RLIB2.
       LOPL-0.
           IF FTRI = ZERO
              MOVE KLV-NPRGI TO COMNPRGI
              MOVE ZERO TO COMCOD COMIVA TOTIMP TOTAIVA
                           COMCAU COMVAL TOTVAL COMTIP
                           COMCDV COMCLF
              GO TO LOPL0.
           MOVE ALL '=' TO RTRA1.
           MOVE 'TOTALE ........' TO DESTOT.
           COMPUTE TOTDOC = TOTIMP + TOTAIVA.
           MOVE TOTDOC TO RTRA3.
           MOVE 'RIG2' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE.
           MOVE KLV-NPRGI TO COMNPRGI.
           MOVE ZERO TO COMCOD COMIVA TOTIMP TOTAIVA
                        COMCAU TOTVAL COMVAL COMTIP
                        COMCDV COMCLF.
       LOPL0.
           IF IF-TPREG = 3   
              PERFORM RCOR THRU EX-RCOR
              GO TO LOPL1.
           PERFORM RLIB THRU EX-RLIB.
       LOPL1.
           DELETE WDSLAV.
           GO TO LOPL.
       ENDB.
           IF IF-TPREG NOT = 3 GO TO ENDB0.
           PERFORM ENDC THRU EX-ENDC.
           IF IF-FLTOT = 1 
              PERFORM STCON THRU EX-STCON
              PERFORM BARTOT THRU EX-BARTOT
              MOVE ZERO TO IF-FLTOT.
           IF IF-TPLIQ = ZERO OR ((T25-PER = 1 OR 2) AND AGGTR = 1)
      **** rel 6.3
      *       PERFORM RPT-CL.
              PERFORM VER-CL.
      ************
           GO TO ECH9.
       ENDB0.
           IF FTRI = ZERO GO TO ENDB1.
           MOVE ALL '=' TO RTRA1.
           MOVE 'TOTALE ........' TO DESTOT.
           COMPUTE TOTDOC = TOTIMP + TOTAIVA.
           MOVE TOTDOC TO RTRA3.
           MOVE 'RIG2' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE.
           MOVE KLV-NPRGI TO COMNPRGI.
       ENDB1.
      **** rel 6.3
           IF IF-INCSOS = 1
              IF FLGST = ZERO
      * controllare quale righe bisogna svuotare.
                 MOVE 'RIG1B' TO RP-BLK
                 PERFORM RPT-AZZ
                 GO TO ECHS.
      ************
      * solo stampa a carattere
           IF RP-TRPT = 1     GO TO ECHS.
           IF NRIG NOT < NRGL GO TO ECHS.
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO P999.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE.
           COMPUTE N = NRGL - NRIG.
           COMPUTE N = N + (132 - N) / 2.
           MOVE N TO K.
           ADD 1 TO N.
       LCHS.    
      **** rel 6.1
      *    IF NRIG NOT < (NRGL - 2) GO TO ECHS. 
           IF NRIG NOT < (NRGL - 3) GO TO ECHS. 
      ************
           ADD 1 TO NRIG.
      **** rel 6.1
      *    IF NRIG = (NRGL - 2)
           IF NRIG = (NRGL - 3)
      ************
              MOVE ALL '=' TO P999 
              MOVE 'RIG4' TO RP-BLK
           ELSE
              SUBTRACT 1 FROM N K
              MOVE '/' TO RX(N) RX(K)
              MOVE 'RIG3' TO RP-BLK.
           SUBTRACT 1 FROM NRIG.  
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
      **** rel 6.1
           PERFORM STA-PIE.
      ************
           GO TO LCHS.
       ECHS.
      **** rel 6.1
      *    PERFORM STA-PIE.
      ************
           IF IF-FLTOT = 1
              PERFORM STCON THRU EX-STCON
              MOVE ZERO TO IF-FLTOT
              PERFORM BARTOT THRU EX-BARTOT.
           IF IF-TPLIQ = ZERO OR (( T25-PER = 1 OR 2) AND AGGTR = 1)
              MOVE NRGL TO NRIG             
      **** rel 6.3
      *       PERFORM RPT-CL.
              PERFORM VER-CL.
      ************
      *------------------
       ECHS0-00.
           IF IF-TPREG NOT = 2 GO TO CLSST1.
       ECH9.
           IF IF-TPLIQ = ZERO
              MOVE ZERO TO CONTA 
              GO TO ENDST.
           IF (T25-PER = 1 OR 2) AND AGGTR = 1 GO TO ECHS0-11.
           PERFORM LIQUID THRU EX-LIQUID.
       ECHS0-11.
           MOVE ZERO TO CONTA.
           IF IV-TSDAT NOT = 1 GO TO RDLK-10.
           IF (T25-PER = 1 OR 2) AND AGGTR = 1 GO TO RDLK-10.
           IF IF-TPLIQ = 1
              MOVE ZERO TO IF-TPLIQ
              GO TO ENDST.
      *
           MOVE 'Aggiornamento totali IVA ?' TO F-MES1.
           MOVE 1   TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP = 'N'
              MOVE ZERO TO IF-TPLIQ
              GO TO ENDST.
      *
           CLOSE TABELL TOTIVA.
      *
           MOVE IF-FL   TO FL-143.
           MOVE ID-TAB  TO ID-TAB-143.
           MOVE ID-IVA  TO ID-IVA-143.
           MOVE TOTIV   TO TOTIV-143.
           MOVE IF-RIMB TO RIMB-143.
           MOVE IF-ACCV TO ACCIVA-143.
           MOVE NMES    TO NMES-143.
           MOVE T25ESE  TO T25ESE-143.
      *
           MOVE IF-DTVE TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO DTVEK-143.
      *
           MOVE COMPE TO COMPE-143.
      *
           CALL 'vcon143' USING PARLINK-143 PARIV.
           CANCEL 'vcon143'.
           IF ERRIO-ST = 9 GO TO ERRIO.
           MOVE COMPE-143 TO COMPE.
           OPEN I-O TOTIVA.
       RDLK-05-90.
           IF IV-TIVAV  = ZERO AND
              IV-TIVAA  = ZERO AND
              IV-TIMPOC = ZERO AND
              IV-TIVACO = ZERO OPEN I-O TABELL 
                               GO TO RDLK-10.
           CLOSE ANAAZI MOVIME MOVMOL.
           IF T25ESE = 1 MOVE 'tabell' TO ID-TAB.
           MOVE 'movime' TO ID-MOV.
           IF IF-FL = 1  MOVE 'movmol' TO ID-MOV.
      *
           MOVE 'Aggiornamenti contabili ?' TO F-MES1.
           MOVE 1   TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP = 'N' GO TO RDL-000.
           MOVE 1 TO IF-HS-145.
           GO TO ENDST.
      * label di rientro per fun = 'S'
       RUN-RIENTRO.
           MOVE ID-AZI   TO ID-AZI-145.
           MOVE ID-TAB   TO ID-TAB-145.
           MOVE ID-MOV   TO ID-MOV-145.
           MOVE IF-FL    TO FL-145.
           MOVE IV-CDAZ  TO CDAZ-145.
           MOVE IF-DTCON TO DTCON-145.
           MOVE IF-DSAGG TO DSAGG-145.
      *
           CALL 'vcon145' USING PARLINK-145 IV-CAMPLAV.
           CANCEL 'vcon145'.
           IF ERRIO-ST = 9 GO TO ERRIO.
       RDL-000.
           IF IF-FL = 1 MOVE 'movime' TO ID-MOV.
           OPEN I-O ANAAZI.
           OPEN INPUT MOVIME.
           OPEN INPUT MOVMOL.
           OPEN  I-O  TABELL.
       RDLK-10.
           MOVE ZERO TO IF-TPLIQ.
           GO TO ENDST.
      **** rel 6.3
      *CLSST.
      *    PERFORM RPT-CL.
      ************
       CLSST1.
           IF IF-TPREG > 1    OR
              T25TSR   = ZERO OR
              DTK  NOT < DT2  GO TO ENDST.
      *
           MOVE SPACE TO F-MES1 F-MES2 F-MES3 F-MES4.
           STRING 'Ultima data attuale : ' IF-DATA-2
                  DELIMITED SIZE INTO F-MES1.
           STRING 'Ultimo protocollo attuale : ' IF-UNAT
                  DELIMITED SIZE INTO F-MES2.
           MOVE ALL '-' TO F-MES3.
           MOVE 'Aggiornamento numerazione acquisto ?' TO F-MES4.
           MOVE 4   TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP = 'N' GO TO ECH9.
           PERFORM Z00-MEM THRU Z99.
       ENDST.
           MOVE ZERO TO CONTA.
      *
      **** rel 6.3
           GO TO NOCL.
       LP-CHIUDI.
           PERFORM RPT-CL.
           MOVE ZERO TO IF-CHIUDI.
       NOCL.
      ************
           COPY 'grirpt-e'.
       EX-RUN-ELABORA.
           EXIT.
      *------------------
      **** rel 6.3
       VER-CL.
           MOVE 'Vuoi ACCODARE una altro periodo' TO F-MES1.
           MOVE 'allo stessa STAMPA?' TO F-MES2.
           MOVE 2   TO F-NMES.
           MOVE 'Q' TO MB-TIPO.
           MOVE '2' TO MB-DEFAULT.
           IF IF-CHIUDI = 9 MOVE '1' TO MB-DEFAULT.
           CALL 'vrmbox' USING PARMB.
           IF MB-RISP = 'S'
              MOVE 9 TO IF-CHIUDI
           ELSE
              MOVE ZERO TO IF-CHIUDI
              PERFORM RPT-CL.
      *------------------
      ************
       RLIB.
           MOVE MOV-CAUS TO COMCAU.
           MOVE 2        TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO REKTAB.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T02-FLVEN TO COM-FLVEN. 
           MOVE T02-TIPOP TO TIPOP.
           MOVE T02-SEGNO TO SEGNO.
           MOVE T02-FLGIS TO FLGIS-02.
           IF MOV-FLAG = 1 GO TO EX-RLIB.
       RLIB0.
           IF MOV-PART = COMCOD GO TO RLIB1.
      **** rel 7.2
           MOVE SPACE TO SAVPIVA.
           MOVE SPACE TO SAVCFISC.
      ************
           MOVE MOV-PART TO KCF-COD COMCOD.
           MOVE 1 TO XCRR.
           MOVE MOV-DAT TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RG1.
           MOVE KAZ-COD TO KCF-AZI.
           READ ANACLF INTO REKCLF INVALID
               MOVE 'INES.' TO CLF-RGS
               MOVE SPACE   TO CLF-RGS2
               MOVE ZERO    TO CLF-13IVA.
           MOVE CLF-13IVA TO COMCLF.
           MOVE MOV-NPRGI TO RV2.
           MOVE CLF-RGS TO RV3.
           IF CLF-RGS2 NOT = SPACE
              MOVE 'RIG1' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              PERFORM STA-PIE
              MOVE CLF-RGS2 TO RV3.
      **** rel 7.2
           IF CLF-PIVA NOT = ZERO
              MOVE CLF-PIVA  TO SAVPIVA.

           IF CLF-CFISC NOT = ZERO AND NOT = SPACE
              MOVE CLF-CFISC TO SAVCFISC.

           IF CLF-PAE = 'IT' AND CLF-IVE(1:11) IS NUMERIC AND
              CLF-IVE(12:) = SPACE
              MOVE CLF-IVE(1:11) TO SAVPIVA.

           IF CLF-13IVA = 4
              IF CLF-PAE NOT = SPACE AND
                 CLF-PAE NOT = 'IT' AND
                 CLF-PAE IS NOT NUMERIC
                 MOVE CLF-CFISC TO COMFISC
                 CALL 'rfisc' USING PARFISC
                 IF RISPFISC NOT = ZERO
                    MOVE SPACE           TO SAVCFISC
                    MOVE CLF-CFCEE(1:14) TO SAVPIVA. 

           IF SAVPIVA  = SPACE AND
              SAVCFISC = SPACE
              GO TO NO-PIVA-FISC.

           MOVE SPACE TO W-IVA-FIS
           IF SAVPIVA NOT = SPACE
              STRING 'P.Iva: ' DELIMITED SIZE
                     SAVPIVA   DELIMITED SIZE
                       INTO W-IVA-FIS
              END-STRING
           ELSE
              STRING 'C.Fis: ' DELIMITED SIZE
                     SAVCFISC  DELIMITED SIZE
                       INTO W-IVA-FIS
              END-STRING
           END-IF.
      *
           IF W-IVA-FIS NOT = SPACE
              MOVE 'RIG1' TO RP-BLK
              PERFORM RPT-WR1 THRU EX-RPT-WR1
              PERFORM STA-PIE
              MOVE W-IVA-FIS TO RV3.
      *
       NO-PIVA-FISC.
      ************
           MOVE MOV-NDOC TO RV4.
           MOVE MOV-DTDOC TO AAGGG.
           CALL 'rdata' USING PARCDT.
           MOVE GBMMBA TO RV5.
      **** rel 6.3
           MOVE MOV-DTDOC TO DTDOC.
      ************
       RLIB1.
      **** rel 7.2
           PERFORM VERIFICA-CONDIZIONE THRU EX-VERIFICA-CONDIZIONE. 
      ************
           IF NOT (SEGNO = 1 OR TIPOP = 8) 
              MOVE SPACE TO RV9.
           IF SEGNO = 1 MOVE 'STORNO CONT.'       TO RV91.
           IF TIPOP = 8 MOVE 'VAR. ART. 26'       TO RV91.
           IF IF-TPREG = 2 AND FLGIS-02 = 1 
      **** rel 7.2
      *                 MOVE 'IMPOSTA SOSP'       TO RV92.
                        IF PGISO-STATO = 1
                           MOVE 'IMP.SCIS.PAG.'      TO RV92
                        ELSE
                           MOVE 'IMPOSTA SOSP'       TO RV92.
      ************
           IF IF-TPREG  = 2 AND FLGIS-02 = 2
              MOVE 010198 TO GGMMAA
              MOVE 1 TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF MOV-DTDOC NOT < AAGGG 
      **** rel 6.1
      *          MOVE 'SALDO ACCREDITO IN SOSPESO' TO RV9 
                 IF TIPOP = 8
                    MOVE 'SALDO ACCREDITO IN SOSPESO' TO RV9
                 ELSE
                    MOVE 'INCASSO FATTURA IN SOSPESO' TO RV9 
                 END-IF
      ************
              ELSE
                 MOVE 'INCASSO EX.REG.FATTURA SOSP.' TO RV9.
           IF MOV-FLGPC > ZERO
              IF MOV-DAT > DT2
      **** rel 7.2
      *          MOVE 'MESE CORRENT' TO RV92
                 MOVE 'COMP.CORRENT.' TO RV92
      ************
              ELSE
      **** rel 7.2
      *          MOVE 'MESE PRECED.' TO RV92.
                 MOVE 'COMP.PRECED.' TO RV92.
      ************
           MOVE MOV-DAT   TO DTMOV.
           MOVE MOV-FLGPC TO FLGPC.
           IF COMIVA NOT = ZERO GO TO RLIB1-00.
           IF TIPOP = 8
              MULTIPLY -1 BY MOV-IMPO
              IF MOV-TIP = 4
                 MULTIPLY -1 BY MOV-IML
                 MULTIPLY -1 BY MOV-INL
                 MULTIPLY -1 BY MOV-IMV
              ELSE
                 MULTIPLY -1 BY MOV-IMP
                 MULTIPLY -1 BY MOV-IVN.
            MOVE MOV-IVA  TO COMIVA.
            MOVE MOV-IMPO TO COMIMPO.
            MOVE MOV-TIP TO COMTIP.
            IF MOV-TIP = 4
               MOVE MOV-IML TO COMIMP
               MOVE MOV-INL TO COMIVN
               MOVE MOV-IMV TO COMVAL
               MOVE MOV-VAL TO COMCDV
            ELSE
               MOVE MOV-IMP  TO COMIMP
               MOVE MOV-IVN  TO COMIVN.
            MOVE MOV-FEV TO COM-FEV.
            GO TO EX-RLIB.
       RLIB1-00.
           IF NOT (COMIVA = MOV-IVA AND MOV-FEV = COM-FEV)
              GO TO RLIB2.
           IF TIPOP = 8
              MULTIPLY -1 BY MOV-IMPO
              IF COMTIP = 4
                 MULTIPLY -1 BY MOV-IML
                 MULTIPLY -1 BY MOV-INL
                 MULTIPLY -1 BY MOV-IMV
              ELSE
                 MULTIPLY -1 BY MOV-IMP
                 MULTIPLY -1 BY MOV-IVN.
           ADD MOV-IMPO TO COMIMPO.
           IF COMTIP = 4
              ADD MOV-IML TO COMIMP
              ADD MOV-INL TO COMIVN
              ADD MOV-IMV TO COMVAL
           ELSE
              ADD MOV-IMP TO COMIMP
              ADD MOV-IVN TO COMIVN.
           GO TO EX-RLIB.
       RLIB2.
           IF IF-TPREG = 3
              PERFORM RCOR2 THRU EX-RCOR2
              GO TO ENDB.
           MOVE COMIMP TO RV6.
           ADD COMIMP TO TOTIMP.
           MOVE 3      TO KTB-TIP.
           MOVE COMIVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                MOVE ZERO  TO REKTAB
                MOVE ZERO  TO T03-ESCEE T03-DECEE
                MOVE SPACE TO T03-DSIVA.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF FLGPC > ZERO AND DTMOV NOT > DT2 GO TO CARV1.
           IF IF-TPREG = 2 AND FLGIS-02 = 1 GO TO CARV1.
           MOVE ZERO TO K5.
       CARV.
           ADD 1 TO K5.
      **** NT 7.1
      *    IF K5 > 50 GO TO CARV1.
           IF K5 > 999 GO TO CARV1.
      **********
           IF CODIVA(K5) = ZERO
              MOVE COMIVA TO CODIVA(K5).
           IF CODIVA(K5) NOT = COMIVA GO TO CARV.
           ADD COMIMP  TO IMPCON(K5).
           ADD COMIMPO TO IVACON(K5).
       CARV1.
      **** rel 7.2
           MOVE ZERO TO W-IND
           IF FLGPC > ZERO 
              IF DTMOV > DT2
                 PERFORM MESE-CORR THRU EX-MESE-CORR
              ELSE
                 PERFORM MESE-PREC THRU EX-MESE-PREC
              END-IF
           ELSE
              PERFORM IVA-D-MESE THRU EX-IVA-D-MESE
           END-IF.
      ************
      **** rel 6.3
           IF IF-TPREG  = 2 AND FLGIS-02 = 2
              MOVE DTDOC TO AAGGG
              MOVE 2     TO TIPOP1
              CALL 'rdata' USING PARCDT
              IF AA4 = ANNELA GO TO OK-CARV-FSA
              ELSE            GO TO OK-CARV-FSP.
      *
           IF IF-TPREG = 2 AND FLGIS-02 = 1 GO TO OK-CARV-FSI.
      *
           GO TO FINE-CARV.
      *
       OK-CARV-FSA.
           MOVE ZERO TO K5.
      **** rel 7.2
           IF PGISO-STATO = 1
              GO TO SCARV-FSA.
      ************
       CARV-FSA.
           ADD 1 TO K5.
      **** rel 7.1
      *    IF K5 > 50 GO TO CARV1-FSA.
           IF K5 > 999 GO TO CARV1-FSA.
      ************
           IF FSA-CODIVA(K5) = ZERO
              MOVE COMIVA TO FSA-CODIVA(K5).
           IF FSA-CODIVA(K5) NOT = COMIVA GO TO CARV-FSA.
           ADD COMIMP  TO FSA-IMPCON(K5).
           ADD COMIMPO TO FSA-IVACON(K5).
       CARV1-FSA.
           GO TO FINE-CARV.
      *
      **** rel 7.2
       SCARV-FSA.
           ADD 1 TO K5.
           IF K5 > 999 GO TO SCARV1-FSA.
           IF SFSA-CODIVA(K5) = ZERO
              MOVE COMIVA TO SFSA-CODIVA(K5).
           IF SFSA-CODIVA(K5) NOT = COMIVA GO TO SCARV-FSA.
           ADD COMIMP  TO SFSA-IMPCON(K5).
           ADD COMIMPO TO SFSA-IVACON(K5).
       SCARV1-FSA.
           GO TO FINE-CARV.
      *
      ************
       OK-CARV-FSP.
           MOVE ZERO TO K5.
      **** rel 7.2
           IF PGISO-STATO = 1
              GO TO SCARV-FSP.
      ************
       CARV-FSP.
           ADD 1 TO K5.
      **** rel 7.1
      *    IF K5 > 50 GO TO CARV1-FSP.
           IF K5 > 999 GO TO CARV1-FSP.
      ************
           IF FSP-CODIVA(K5) = ZERO
              MOVE COMIVA TO FSP-CODIVA(K5).
           IF FSP-CODIVA(K5) NOT = COMIVA GO TO CARV-FSP.
           ADD COMIMP  TO FSP-IMPCON(K5).
           ADD COMIMPO TO FSP-IVACON(K5).
       CARV1-FSP.
           GO TO FINE-CARV.
      *
      **** rel 7.2
       SCARV-FSP.
           ADD 1 TO K5.
           IF K5 > 999 GO TO SCARV1-FSP.
           IF SFSP-CODIVA(K5) = ZERO
              MOVE COMIVA TO SFSP-CODIVA(K5).
           IF SFSP-CODIVA(K5) NOT = COMIVA GO TO SCARV-FSP.
           ADD COMIMP  TO SFSP-IMPCON(K5).
           ADD COMIMPO TO SFSP-IVACON(K5).
       SCARV1-FSP.
           GO TO FINE-CARV.
      *
      ************
       OK-CARV-FSI.
           MOVE ZERO TO K5.
      **** rel 7.2
           IF PGISO-STATO = 1
              GO TO SCARV-FSI.
      ************
       CARV-FSI.
           ADD 1 TO K5.
      **** rel 7.1
      *    IF K5 > 50 GO TO CARV1-FSI.
           IF K5 > 999 GO TO CARV1-FSI.
      ************
           IF FSI-CODIVA(K5) = ZERO
              MOVE COMIVA TO FSI-CODIVA(K5).
           IF FSI-CODIVA(K5) NOT = COMIVA GO TO CARV-FSI.
           ADD COMIMP  TO FSI-IMPCON(K5).
           ADD COMIMPO TO FSI-IVACON(K5).
       CARV1-FSI.
      *
      **** rel 7.2
           GO TO FINE-CARV.
       SCARV-FSI.
           ADD 1 TO K5.
           IF K5 > 999 GO TO SCARV1-FSI.
           IF SFSI-CODIVA(K5) = ZERO
              MOVE COMIVA TO SFSI-CODIVA(K5).
           IF SFSI-CODIVA(K5) NOT = COMIVA GO TO SCARV-FSI.
           ADD COMIMP  TO SFSI-IMPCON(K5).
           ADD COMIMPO TO SFSI-IVACON(K5).
       SCARV1-FSI.
           GO TO FINE-CARV.
      *
      ************
       FINE-CARV.
      ************
           MOVE T03-DSIVA TO RV7 RV7G.
           MOVE COMIMPO   TO RV8 RV8G.
           ADD COMIMPO TO TOTAIVA.
           IF (COMTIP = 4 OR COMCLF = 4) AND T03-ESCEE = ZERO
              MOVE 'CEE' TO RV93.
           IF T03-TPIVA = ZERO GO TO STAMR.
           IF IF-TPREG = 1 AND T03-TPIVA = 1
              MOVE 'IVA INDETR. '     TO RV91
              GO TO STAMQ.
           IF T03-ALIVA = ZERO MOVE TAB-DESCR TO RV69 RV7G
                               MOVE SPACE TO RV8G-X.
           IF T03-TPIVA < 7 GO TO STAMR.
           IF IF-TPREG NOT = 1 GO TO STAMS.
           MOVE SPACE TO RV91.
           MOVE COMIMP TO CLAV.
      **** rel 6.2
      *    COMPUTE CLV1 = CLAV / 2.
           IF T03-PERIVA = ZERO MOVE 50 TO T03-PERIVA.
           COMPUTE CLV1 = CLAV * T03-PERIVA / 100.
      ************
           COMPUTE CLV2 = CLAV - CLV1.
           MOVE CLV2 TO RV6.
           MOVE COMIMPO TO RV8 RV8G.
           MOVE 'RIG1' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE.
           MOVE CLV1 TO RV6.
       STAMQ.
           MOVE COMIVN TO RV8 RV8G.
           ADD COMIVN TO TOTAIVA.
      **** rel 7.2
      *    IF FLGPC = ZERO OR DTMOV > DT2 OR
      *       IF-TPREG NOT = 2 OR FLGIS-02 NOT = 1
      *          ADD COMIVN TO INDCON(K5).
      ************
      **** rel 7.2
           IF IF-TPREG NOT = 2 OR FLGIS-02 NOT = 1
              MOVE 1 TO W-IND
              IF FLGPC > ZERO 
                 IF DTMOV > DT2
                    PERFORM MESE-CORR THRU EX-MESE-CORR
                    MOVE 'COMP.CORRENT.' TO RV92
                    PERFORM IVA-IVN THRU EX-IVA-IVN
                 ELSE
                    PERFORM MESE-PREC THRU EX-MESE-PREC
                    MOVE 'COMP.PRECED.' TO RV92
                 END-IF
              ELSE
                 PERFORM IVA-D-MESE THRU EX-IVA-D-MESE
                 PERFORM IVA-IVN THRU EX-IVA-IVN
              END-IF
           END-IF.
      ************

           MOVE T03-DSIVA TO RV7 RV7G.
           MOVE 'IVA INDETR. '     TO RV91.
       STAMR.
           IF COM-FLVEN     = ZERO OR
              COM-FEV       = 1    OR
              T03-TPIVA NOT = ZERO GO TO STAMS.
           IF IF-TPREG NOT = 1 GO TO STAMS.
           MOVE 'ACQ.RIVEND.-'              TO RV91.
           IF SEGNO = 1 MOVE 'ACQ.RIV.-ST.' TO RV91.
           IF TIPOP = 8 MOVE 'ACQ.RIV-A.26' TO RV91.
       STAMS.
           MOVE 'RIG1' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE.
           MOVE ZERO TO COMIMP COMIMPO COMIVN COMIVA.
           IF COMTIP NOT = 4 GO TO STAMS-10.
           IF COMCDV = ZERO OR COMVAL = ZERO GO TO STAMS-10.
           MOVE 10      TO KTB-TIP.
           MOVE COMCDV  TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE SPACE TO T10-DSINT.
           MOVE T10-DSINT TO RV51.
           MOVE COMVAL TO RV6.
           MOVE 'RIG1' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE.
           MOVE ZERO TO COMVAL.
       STAMS-10.
           MOVE ZERO TO COMTIP COMCDV.
           IF SW = 1 GO TO ENDB.
           IF SW = 2
              MOVE ZERO TO SW
              GO TO LOPL-0 
           ELSE
              GO TO RLIB0.
       EX-RLIB.
           EXIT.
      *------------------
       RCOR.
           IF MOV-FLAG = 1 GO TO EX-RCOR.
           IF DATAS = ZERO
              MOVE MOV-DAT TO DATAS
              MOVE 1 TO XCRR
              MOVE DATAS TO AAGGG
              MOVE 2 TO TIPOP1
              CALL 'rdata' USING PARCDT
              MOVE GBMMBA TO RGP1.
           IF DATAS NOT = MOV-DAT
              PERFORM RCOR2 THRU EX-RCOR2
              MOVE ZERO TO DATAS COMIVA COMNPRGI
                           NUMAX COMODO
              MOVE 99999 TO NUMIN
              GO TO RCOR.
           IF COMNPRGI = ZERO MOVE MOV-TIP TO COMNPRGI.  
           IF COMNPRGI NOT = MOV-TIP
              PERFORM  RCOR2 THRU EX-RCOR2
              MOVE ZERO TO COMIVA NUMAX COMODO
              MOVE MOV-TIP TO COMNPRGI
              MOVE 99999 TO NUMIN.
           IF COMIVA = ZERO MOVE MOV-IVA TO COMIVA.
           IF COMIVA NOT = MOV-IVA
              PERFORM RCOR2 THRU EX-RCOR2
              MOVE ZERO TO NUMAX COMODO
              MOVE 99999 TO NUMIN
              MOVE MOV-IVA TO COMIVA.
           MOVE 2        TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           PERFORM VISK-MOV
                                           GO TO ERRIO.
           IF MOV-TREG = 2 AND T02-TIPOP = 8 
              MULTIPLY -1 BY MOV-IMP
              MULTIPLY -1 BY MOV-IVN.
           MOVE ZERO TO K5.
       RCOR1.
           ADD 1 TO K5.
      **** NT 7.1
      *    IF K5 > 50
      *       MOVE 50 TO K5
           IF K5 > 999
              MOVE 999 TO K5
      **********
              MOVE COMIVA TO CODIVA(K5).
           IF CODIVA(K5) = ZERO MOVE COMIVA TO CODIVA(K5).
           IF CODIVA(K5) NOT = COMIVA GO TO RCOR1.
           ADD MOV-IMP TO IMPCON(K5) COMODO.
           IF MOV-TREG = 1 GO TO EX-RCOR.
           ADD MOV-IVN TO IMPCON(K5) COMODO.
           IF MOV-NDOC < NUMIN MOVE MOV-NDOC TO NUMIN.
           IF MOV-NDOC > NUMAX MOVE MOV-NDOC TO NUMAX.
       EX-RCOR.
           EXIT.
      *------------------
       RCOR2.
           IF COMNPRGI < 2 
              MOVE COMODO TO RGP2
           ELSE
              MOVE COMODO TO RGP3.
           MOVE 3      TO KTB-TIP.
           MOVE COMIVA TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO REKTAB.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF COMIVA = 999
              MOVE 'DA VENTILARE' TO RGP4
           ELSE
              IF T03-ALIVA = ZERO
                 MOVE TAB-DESCR TO RGP4
              ELSE
                 MOVE T03-DSIVA TO RGP4.
           IF NUMAX NOT = ZERO 
              IF NUMIN = NUMAX 
                 MOVE 'COMPRESA FATTURA     N.' TO RGPF
                 MOVE NUMIN TO RGFT1
              ELSE
                 MOVE 'COMPRESE FATTURE DAL N.' TO RGPF
                 MOVE NUMIN TO RGFT1
                 MOVE NUMAX TO RGFT2
                 MOVE 'AL N.' TO RGPF2.
           MOVE 'RIG1B' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-B.
       EX-RCOR2.
           EXIT.
       ENDC.
      * solo stampa a carattere
           IF RP-TRPT = 1     GO TO ENDC2.
           IF NRIG NOT < NRGL GO TO ENDC2.
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO P999B.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3B' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-B.
           COMPUTE N = NRGL - NRIG.
           COMPUTE N = N + (132 - N) / 2.
           MOVE N TO K.
           ADD 1 TO N.
       ENDC1.    
      **** rel 6.1
      *    IF NRIG NOT < (NRGL - 2) GO TO ENDC2.
           IF NRIG NOT < (NRGL - 3) GO TO ENDC2.
      ************
           ADD 1 TO NRIG.
      **** rel 6.1
      *    IF NRIG = (NRGL - 2)
           IF NRIG = (NRGL - 3)
      ************
              MOVE ALL '=' TO P999B 
              MOVE 'RIG3B' TO RP-BLK
           ELSE
              SUBTRACT 1 FROM N K
              MOVE '/' TO RXB(N) RXB(K)
              MOVE 'RIG2B' TO RP-BLK.
           SUBTRACT 1 FROM NRIG.   
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
      **** rel 6.1
           PERFORM STA-PIE-B.
      ************
           GO TO ENDC1.
       ENDC2.
      **** rel 6.1
      *    PERFORM STA-PIE-B.
      ************
           MOVE NRGL TO NRIG.
       EX-ENDC.
           EXIT.
      *------------------
      * preparazione dati per prospetto a video della liquidazione IVA
       VISIVA.
           MOVE ZERO TO IF-HS-ULTRIN
                        IF-HS-W-DB1
                        IF-HS-ACCV
                        IF-HS-PER-D
                        IF-HS-DTVE
                        IF-HS-RIMB.
           MOVE ZERO TO SAV-ACREDI
                        SAV-DAVERS.
           MOVE IF-DATA-1 TO DAT1.
           IF IF-TPREG = 1
              IF T25TSR = ZERO OR DTK NOT < DT2
                 GO TO EX-VISIVA
              ELSE 
                 MOVE 1 TO IF-HS-ULTRIN
                 GO TO EX-VISIVA.
           IF IF-FLPRO = ZERO GO TO EX-VISIVA.
      * abilitazione show finestra prospetto liquidazione IVA
           MOVE 1 TO IF-HS-W-DB1.
      *
           MOVE 1 TO GG1.
           IF T25PER = ZERO GO TO VIS-10.
           MOVE 1 TO MM1.
           IF MM2 > 3 AND < 7  MOVE 4 TO MM1.
           IF MM2 > 6 AND < 10 MOVE 7 TO MM1.
           IF MM2 > 9 MOVE 10 TO MM1.
       VIS-10.
           MOVE T25-DUP TO AAGGG.
           MOVE 2 TO TIPOP1
           CALL 'rdata' USING PARCDT.
      **** rel 6.1
      *    IF MM9 = 12 MOVE ZERO TO MM9.
           IF MM9 = 12 AND AA2 < AA1 MOVE ZERO TO MM9.
           IF MM9 > MM1 AND AA2 = AA1 GO TO VIS-15.
      ************
           COMPUTE N = MM1 - MM9.
           IF N = ZERO GO TO VIS-15.
           IF N = 1 MOVE ZERO TO N GO TO VIS-15.
           MOVE 'Periodo precedente non aggiornato' TO F-MES1.
           MOVE 1 TO F-NMES.
           CALL 'vrmbox' USING PARMB.
       VIS-15.
           MOVE DAT1 TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTMOV-1.
           MOVE AAGGG TO IV-DTINK.
           MOVE DT2 TO IV-DTFIK.
           CLOSE TABELL TOTIVA MOVIME MOVMXX MOVMOL MOVOXX MOVIVT.
      *
           MOVE ID-IVA TO ID-IVA-142.
           MOVE ID-TAB TO ID-TAB-142.
      *
           CALL 'vcon142' USING PARLINK-142 PARIV.
           CANCEL 'vcon142'.
           IF ERRIO-ST = 9 GO TO ERRIO.
           PERFORM READ-DPEIVA-MESE THRU EX-READ-DPEIVA-MESE.
      *
           MOVE IV-IVAVEN TO IF-IVEN.
           MOVE IV-IVAACQ TO IF-IACQ.
           MOVE IV-IVACOR TO IF-ICOR.
           MOVE IV-IVAULT TO IF-ULTDE.
           MOVE IV-DEP0   TO IF-PRORA.
      *
           MOVE IV-DTPK TO DTPK AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO IF-DTMOV-2.
           OPEN INPUT MOVIME MOVMXX MOVMOL MOVOXX MOVIVT.
           OPEN I-O TOTIVA TABELL.
           MOVE KAZ-COD TO T25-COD.
           MOVE '0'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE ZERO TO IF-DPREC IF-CPREC.
           IF IV-TSDAT = 1 MOVE T25-PPR TO IF-CPREC
                           GO TO VIS-20.
           IF MM1 = 1 MOVE ZERO    TO IF-CPREC
                      GO TO VIS-20.
           SUBTRACT 1 FROM MM1.
           MOVE IMLIQ(MM1) TO IF-CPREC.
       VIS-20.
           IF IF-CPREC < ZERO
              COMPUTE IF-DPREC = IF-CPREC * -1
              MOVE ZERO TO IF-CPREC
           ELSE
              MOVE ZERO TO IF-DPREC.     
           IF IV-TSDAT NOT = ZERO OR MM1 = 1 GO TO VIS-40.
           ADD 1 TO MM1.
           IF IF-CPREC NOT = ZERO
              IF MM1 = 3 OR 6 OR 9
                 IF DT2 > T25-DUP
                    COMPUTE IF-CPREC = IF-CPREC - IF-VP19C - IF-VP19R.
              IF MM1 = 4 OR 7 OR 10
                 IF DT2 NOT > T25-DUP
                    COMPUTE IF-CPREC = IF-CPREC - IF-VP19C - IF-VP19R.
       VIS-40.
           IF IF-DPREC NOT < T25-MIN MOVE ZERO TO IF-DPREC.
           MOVE ZERO TO TOTIV IF-IMDE IF-IMCR.
           IF IV-CDCOR = ZERO MOVE ZERO TO IV-IVACOR.
           MOVE ZERO TO TOTIVD TOTIVC TOTIND0.
           MOVE ZERO TO TOTIVCN.
           COMPUTE TOTIVD = IV-IVAVEN + IV-IVACOR.
           MOVE IV-DTINK TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO ANNO4.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVD > 0 ADD EARROT TO TOTIVD
              ELSE          SUBTRACT EARROT FROM TOTIVD
              END-IF
              COMPUTE TOTIVD = TOTIVD / 100
              COMPUTE TOTIVD = TOTIVD * 100. 
      *
           COMPUTE TOTIVC = IV-IVAACQ + IV-IVAULT.
           IF IV-DEP0 = ZERO AND IV-INDEP0 NOT = ZERO
              COMPUTE TOTIVC = IV-IVAACQ + IV-IVAULT - IV-INDEP0.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVC > 0 ADD EARROT TO TOTIVC
              ELSE          SUBTRACT EARROT FROM TOTIVC
              END-IF
              COMPUTE TOTIVC = TOTIVC / 100
              COMPUTE TOTIVC = TOTIVC * 100. 
      *
           IF IV-DEP0 NOT = ZERO OR T25IND NOT = ZERO
              COMPUTE TOTIVCN = IV-DEP0 + IV-IVAULT.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVCN > 0 ADD EARROT TO TOTIVCN
              ELSE           SUBTRACT EARROT FROM TOTIVCN
              END-IF
              COMPUTE TOTIVCN = TOTIVCN / 100
              COMPUTE TOTIVCN = TOTIVCN * 100.
      *
           IF TOTIVCN NOT = ZERO
              COMPUTE TOTIV = TOTIVD - TOTIVCN
           ELSE
              COMPUTE TOTIV = TOTIVD - TOTIVC.
           MOVE ZERO TO IF-VP7D.
           MOVE ZERO TO IF-VP7C.
           MOVE ZERO TO IF-VP12C.
           MOVE ZERO TO IF-VP12D.
           IF TOTIV > ZERO MOVE TOTIV TO IF-VP7D
           ELSE            COMPUTE IF-VP7C = TOTIV * - 1.
           MOVE ZERO TO IF-IMDE IF-IMCR.
           IF IF-VP7C NOT = ZERO GO TO VIS-41.
           COMPUTE IF-VP12D =  IF-VP7D + IF-VP8 + IF-VP9 + IF-DPREC -
                               IF-CPREC - IF-VP11.
           MOVE IF-VP12D TO TOTIV.
           IF IF-VP12D < ZERO COMPUTE IF-VP12C = IF-VP12D * - 1
                              MOVE ZERO TO IF-VP12D.
           GO TO VIS-42.
       VIS-41.
           COMPUTE IF-VP12C = IF-VP7C - IF-VP8 - IF-VP9 - IF-DPREC +
                              IF-CPREC + IF-VP11.
           COMPUTE TOTIV = IF-VP12C * - 1.
           IF IF-VP12C < ZERO COMPUTE IF-VP12D = IF-VP12C * - 1
                              MOVE ZERO TO IF-VP12C.
       VIS-42.
           MOVE ZERO TO IF-DAVERS IF-ACREDI.
           IF IF-VP12D NOT = ZERO
              COMPUTE IF-DAVERS = IF-VP12D - IF-VP13.
           IF IF-VP12C NOT = ZERO
              COMPUTE IF-ACREDI = IF-VP12C + IF-VP13.
           IF IF-DAVERS < ZERO COMPUTE IF-ACREDI = IF-DAVERS * - 1
              MOVE ZERO TO IF-DAVERS.
           IF IF-ACREDI < ZERO COMPUTE IF-DAVERS = IF-ACREDI * - 1
              MOVE ZERO TO IF-ACREDI.
      * abilitazione/disabilitazione del campo 'acconto versato'
           IF NMES NOT = 12
              MOVE ZERO TO IF-ACCV
              MOVE ZERO TO IF-HS-ACCV
           ELSE
              MOVE 1 TO IF-HS-ACCV. 
           SUBTRACT IF-ACCV FROM TOTIV.
           MOVE IF-ACREDI TO SAV-ACREDI.
           MOVE IF-DAVERS TO SAV-DAVERS.
           IF IF-DAVERS NOT = ZERO
              SUBTRACT IF-ACCV FROM IF-DAVERS.
           IF IF-DAVERS < ZERO
              COMPUTE IF-ACREDI = IF-DAVERS * - 1
              MOVE ZERO TO IF-DAVERS
              GO TO NOACC.
           IF IF-ACREDI NOT = ZERO
              COMPUTE IF-ACREDI = IF-ACREDI + IF-ACCV.
       NOACC.
           MOVE ZERO TO AGGTR.
           MOVE SPACE TO IF-PER-D.
           IF T25-PER = ZERO
              STRING MESE(NMES) DELIMITED ' '
                     ' ' ANNO   DELIMITED SIZE
                                INTO IF-PER-D
           ELSE
              IF (NMES = 3 OR 6 OR 9 OR 12)
                 DIVIDE 3 INTO NMES 
                 STRING TRIM (NMES) DELIMITED SIZE
                           ' ' ANNO DELIMITED SIZE      
                                    INTO IF-PER-D
                 MULTIPLY 3 BY NMES
              ELSE
                 MOVE 1 TO AGGTR.
           IF TOTIV < ZERO MOVE TOTIV TO IF-IMCR
                           COMPUTE IF-IMCR = IF-IMCR * -1
                           MOVE ZERO TO IF-IMDE
                   ELSE
                           MOVE TOTIV TO IF-IMDE
                           MOVE ZERO  TO IF-IMCR.
            IF ( T25-PER = 1 OR 2 ) AND
                           TOTIV > ZERO
                           COMPUTE IF-IMIN = IF-IMDE * T25-TAS
                           COMPUTE IF-IMIN = ( IF-IMIN / 100 ) + 0,0049
                           COMPUTE IF-DAVERS = IF-DAVERS + IF-IMIN
                           COMPUTE SAV-DAVERS = SAV-DAVERS + IF-IMIN.
           IF NMESE = ( 3 OR 6 OR 9 ) MOVE 1    TO IF-HS-RIMBO
           ELSE                       MOVE ZERO TO IF-HS-RIMBO.
       CKDATI.
           PERFORM CONTROLLO THRU EX-CONTROLLO.
       CNFLIQ.
      * abilitazione richiesta descrizione periodo
           MOVE 1 TO IF-HS-PER-D.
           IF IF-DAVERS = ZERO GO TO RIMB00.
           IF IF-DAVERS < T25-MIN GO TO VISIV9.
      * abilitazione richiesta estremi versamento
           MOVE 1 TO IF-HS-DTVE.
       RIMB00.
           IF NOT (NMES = 3 OR 6 OR 9) GO TO VISIV9.
           IF T25-RIM = ZERO GO TO COMP00.
           MOVE IF-VP19R TO IF-RIMB.
           SUBTRACT IF-RIMB FROM IF-IMCR.
       COMP00.
           IF T25-CIC = ZERO GO TO VISIV9.
           MOVE IF-VP19C TO COMPE.
           SUBTRACT COMPE FROM IF-IMCR.
       VISIV9.
      *
       EX-VISIVA.
           EXIT.  
      *------------------
       LIQUID.
           MOVE IF-PER-D TO TSX4.
           MOVE '-PER TUTTE LE ATTIVITA''- ' TO TSXX2.
           IF IV-CDCOR NOT = ZERO
              MOVE DESCOR  TO RDESCOR
              MOVE TESCOR  TO RTESCOR
              MOVE TESCOR1 TO RTESCOR1.
      *-- inizializza parametri per stampa a caratteri --*
           IF IF-LMOD = 12
              MOVE 72 TO NRGF
              MOVE 64 TO NRGL
           ELSE
              MOVE 66 TO NRGF
              MOVE 58 TO NRGL.
           MOVE 4       TO NINT.
           MOVE C-TINTC-1 TO XTINT(1).
           MOVE C-TINTC-2 TO XTINT(2).
           MOVE C-TINTC-3 TO XTINT(3).
           MOVE C-TINTC-4 TO XTINT(4).
      *--------------------------------------------------*
      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
      *
           MOVE SPACE TO RP-TIT2.
           STRING 'LIQUIDAZIONE IVA ' TSX4 TSXX2
                     DELIMITED SIZE INTO RP-TIT2.
      *
           PERFORM RPT-RIG1C-INTC.
      *
      *    MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
           MOVE ZERO TO K4.
       LOPST-13.
           ADD 1 TO K4.
      **** NT 7.1
      *    IF K4 > 50 GO TO STOT.
           IF K4 > 999 GO TO STOT.
      **********
           IF IV-CDIVAL(K4) = ZERO GO TO STOT.
           MOVE 3             TO KTB-TIP.
           MOVE IV-CDIVAL(K4) TO KTB-COD.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA    TO RGL1.
           MOVE TAB-DESCR    TO RGL2.
           MOVE IV-IMPOV(K4) TO RGL3.
           MOVE IV-IVAV(K4)  TO RGL4.
           MOVE IV-IMPOA(K4) TO RGL5.
           MOVE IV-IVAA(K4)  TO RGL6.
           MOVE IV-INDA(K4)  TO RGL7.
           IF IV-CDCOR = ZERO GO TO STRS.
           MOVE IV-INCAC(K4) TO RGL8.
           MOVE IV-IMPOC(K4) TO RGL9.
           MOVE IV-IVACO(K4) TO RGL10.
       STRS.
           MOVE 'RIG1C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           MOVE 1 TO XCRR.
           IF IV-ULDET(K4) NOT = ZERO
              MOVE 'ULTERIORE DETRAZIONE' TO RGL2
              MOVE IV-ULDET(K4) TO RGL6
              MOVE 'RIG1C' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              PERFORM STA-PIE-C.
           MOVE 1 TO XCRR.
           IF IV-ULDE2(K4) NOT = ZERO
              MOVE 'ULTERIORE DETRAZ.(2)' TO RGL2
              MOVE IV-ULDE2(K4) TO RGL6
              MOVE 'RIG1C' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              PERFORM STA-PIE-C.
           MOVE 1 TO XCRR.
           GO TO LOPST-13.
       STOT.
           MOVE ALL '-' TO RGL3X RGL4X RGL5X RGL6X 
                           RGL7X RGL8X RGL9X RGL10X.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           MOVE 'T O T A L I  ' TO RGL2.
           MOVE IV-TIMPOV TO RGL3.
           MOVE IV-TIVAV  TO RGL4.
           MOVE IV-TIMPOA TO RGL5.
           MOVE IV-TIVAA  TO RGL6.
           MOVE IV-TINDA  TO RGL7.
           IF IV-CDCOR = ZERO GO TO STOT-0. 
           MOVE IV-TINCAC TO RGL8.
           MOVE IV-TIMPOC TO RGL9.
           MOVE IV-TIVACO TO RGL10. 
       STOT-0.
           MOVE 'RIG1C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           IF IV-TULDET NOT = ZERO 
              MOVE 1 TO XCRR
              MOVE 'ULTERIORE DETRAZIONE' TO RGL2
              MOVE IV-TULDET TO RGL6
              MOVE 'RIG1C' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              PERFORM STA-PIE-C.
           IF IV-DEP0 NOT = ZERO OR IV-INDEP0 NOT = ZERO
              MOVE 1 TO XCRR
              MOVE 'IVA DETRAIB.PRO-RATA' TO RGL2
              MOVE IV-DEP0 TO RGL6
              MOVE 'RIG1C' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              PERFORM STA-PIE-C.
           MOVE ALL '=' TO RGL3X RGL4X RGL5X RGL6X 
                           RGL7X RGL8X RGL9X RGL10X.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           IF IF-DPREC  = ZERO AND
              IF-CPREC  = ZERO AND                     
              IV-IVAVEN = ZERO AND
              IV-IVACOR = ZERO AND                     
              IV-IVAACQ = ZERO AND                     
              IV-IVAULT = ZERO AND                     
              IV-DEP0   = ZERO AND
              TOTIV     = ZERO GO TO STPRO-10.
      * riga vuota visuale
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
      * riga vuota visuale
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           MOVE 4 TO XCRR.
           MOVE 'LIQUIDAZIONE' TO DESCRI.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           MOVE 1 TO XCRR.
           MOVE '------------' TO DESCRI.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           MOVE '         DEBITI' TO DEBITI.
           MOVE '        CREDITI' TO CREDITI.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           MOVE 1 TO XCRR.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           IF IF-CPREC = ZERO AND IF-DPREC = ZERO GO TO STPRO-1.
       STPRO-1.
           COMPUTE TOTIVD = IV-IVAVEN + IV-IVACOR.
           MOVE IV-DTINK TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AA4 TO ANNO4.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVD > 0 ADD EARROT TO TOTIVD
              ELSE          SUBTRACT EARROT FROM TOTIVD
              END-IF
              COMPUTE TOTIVD = TOTIVD / 100
              COMPUTE TOTIVD = TOTIVD * 100. 
           IF TOTIVD = ZERO GO TO STPRO-2.
           MOVE 'IVA VENDITE / CORRISPETTIVI ......:' TO DESCRI.
           MOVE TOTIVD TO VALORE.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
       STPRO-2.
           COMPUTE TOTIVC = IV-IVAACQ + IV-IVAULT.
           IF IV-DEP0 = ZERO AND IV-INDEP0 NOT = ZERO
              COMPUTE TOTIVC = IV-IVAACQ + IV-IVAULT - IV-INDEP0.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVC > 0 ADD EARROT TO TOTIVC
              ELSE          SUBTRACT EARROT FROM TOTIVC
              END-IF
              COMPUTE TOTIVC = TOTIVC / 100
              COMPUTE TOTIVC = TOTIVC * 100. 
           MOVE ZERO TO TOTIVCN.
           IF IV-DEP0 NOT = ZERO OR T25IND NOT = ZERO
              COMPUTE TOTIVCN = IV-DEP0 + IV-IVAULT.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVCN > 0 ADD EARROT TO TOTIVCN
              ELSE          SUBTRACT EARROT FROM TOTIVCN
              END-IF
              COMPUTE TOTIVCN = TOTIVCN / 100
              COMPUTE TOTIVCN = TOTIVCN * 100.
           IF TOTIVC = ZERO AND IV-IVAACQ = ZERO
              GO TO STPRO-4.
           MOVE 'IVA ACQUISTI / ULT.DETRAZ. .......:' TO DESCRI.
           MOVE IV-IVAACQ TO TOTIVCP.
           IF ANNO4 = 2000 OR 2001
              IF TOTIVCP > 0 ADD EARROT TO TOTIVCP
              ELSE          SUBTRACT EARROT FROM TOTIVCP
              END-IF
              COMPUTE TOTIVCP = TOTIVCP / 100
              COMPUTE TOTIVCP = TOTIVCP * 100.
           IF IV-IVAACQ NOT = ZERO AND TOTIVC = ZERO
              MOVE TOTIVCP TO VALORC
           ELSE
              MOVE TOTIVC TO VALORC.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
       STPRO-4.
           IF IV-DEP0 = ZERO AND IV-INDEP0 = ZERO
              GO TO STPRO-43.
           MOVE 'IVA DEDUCIBILE PRO-RATA ..........:' TO DESCRI.
           MOVE IV-DEP0 TO TOTIND0.
           IF ANNO4 = 2000 OR 2001
              IF TOTIND0 > 0 ADD EARROT TO TOTIND0
              ELSE           SUBTRACT EARROT FROM TOTIND0
              END-IF
              COMPUTE TOTIND0 = TOTIND0 / 100
              COMPUTE TOTIND0 = TOTIND0 * 100. 
           MOVE TOTIND0 TO VALORC.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
       STPRO-43.
           IF TOTIVCN NOT = ZERO 
              COMPUTE TOTIV = TOTIVD - TOTIVCN 
           ELSE
              COMPUTE TOTIV = TOTIVD - TOTIVC.
           MOVE ZERO TO IF-VP7D IF-VP7C.
           IF TOTIV > ZERO MOVE TOTIV TO IF-VP7D
           ELSE
           COMPUTE IF-VP7C = TOTIV * - 1. 
           MOVE 'VARIAZ.IMPOSTA E INTER. PER.PREC..:' TO DESCRI.
           IF IF-VP8 < ZERO
              COMPUTE VALORC = IF-VP8 * - 1
           ELSE
              MOVE IF-VP8 TO VALORE.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           MOVE 'IVA NON VERS. E INTER. PER. PREC..:' TO DESCRI.
           MOVE IF-VP9 TO VALORE.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           IF IF-DPREC NOT = ZERO
              MOVE 'DEBITO IVA PERIODO PRECEDENTE.....:' TO DESCRI
              MOVE IF-DPREC  TO VALORE 
              MOVE 'RIG2C' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              PERFORM STA-PIE-C.
           IF IF-CPREC NOT = ZERO
              MOVE 'CREDITO IVA PERIODO PRECEDENTE....:' TO DESCRI
              MOVE IF-CPREC TO VALORC
              MOVE 'RIG2C' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              PERFORM STA-PIE-C.
           MOVE 'CRED.IVA COMPENSABILE DETRATTO....:' TO DESCRI.
           MOVE IF-VP11 TO VALORC. 
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           MOVE ZERO TO IF-VP12D IF-VP12C.
           IF IF-VP7C > ZERO GO TO STPRO-48.
           COMPUTE IF-VP12D = IF-VP7D + IF-VP8 + IF-VP9 
              + IF-DPREC - IF-CPREC - IF-VP11. 
           MOVE IF-VP12D TO TOTIV.
           IF IF-VP12D < ZERO COMPUTE IF-VP12C = IF-VP12D * - 1 
              MOVE ZERO TO IF-VP12D. 
           GO TO STPRO-49.
       STPRO-48.
           COMPUTE IF-VP12C = IF-VP7C - IF-VP8 - IF-VP9 
              - IF-DPREC + IF-CPREC + IF-VP11. 
           IF IF-VP12C < ZERO COMPUTE IF-VP12D = IF-VP12C * - 1 
              MOVE ZERO TO IF-VP12C. 
       STPRO-49.
           IF IF-VP12D NOT = ZERO
              MOVE 'IVA DOVUTA PER IL PERIODO.........:' TO DESCRI 
              MOVE IF-VP12D TO VALORE.
           IF IF-VP12C NOT = ZERO
              MOVE 'IVA A CREDITO PER IL PERIODO......:' TO DESCRI 
              MOVE IF-VP12C TO VALORC.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           MOVE 'CREDITI SPECIALI IMPOSTA DETRATTI.:' TO DESCRI.
           MOVE IF-VP13  TO VALORC. 
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           IF IF-VP12D NOT = ZERO 
              COMPUTE TOTIV = IF-VP12D - IF-VP13.
           IF IF-VP12C NOT = ZERO 
              COMPUTE TOTIV = ( IF-VP12C * - 1 )  - IF-VP13.
           IF IF-ACCV = ZERO GO TO STPRO-51A.
           MOVE 'ACCONTO VERSATO ..................:' TO DESCRI.
           MOVE IF-ACCV TO VALORC.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           MOVE 1 TO XCRR.
       STPRO-51A.
           SUBTRACT IF-ACCV FROM TOTIV.
           IF TOTIV = ZERO GO TO STPRO-52.                             
           IF TOTIV > ZERO 
                MOVE TOTIV TO TOTALE
                MOVE
                'DEBITO IVA .......................:' TO DESCRI
                MOVE TOTALE TO VALORE
           ELSE 
                MOVE TOTIV TO TOTALE
                MULTIPLY -1 BY TOTALE 
                MOVE TOTALE TO VALORC
                MOVE
                'CREDITO IVA ......................:' TO DESCRI.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           IF T25-PER = ZERO GO TO STPRO-52.
           IF NOT ( NMES = 3 OR 6 OR 9 OR 12 ) GO TO STPRO-53.
       STPRO-52.
           IF TOTIV > ZERO OR  ( IF-RIMB = ZERO AND COMPE = ZERO ) 
              GO TO STPRO-53.
           MOVE TOTIV TO TOTALE.
           MULTIPLY -1 BY TOTALE.
           MOVE 'TOTALE IMPORTO A CREDITO .........:' TO DESCRI.
           MOVE TOTALE TO VALORE.
           IF IF-RIMB = ZERO GO TO NORIMB.
           SUBTRACT IF-RIMB FROM TOTALE.
           ADD IF-RIMB TO TOTIV.
           MOVE TOTALE TO IMPVE.
           MOVE IF-RIMB TO TOTALE.
           IF ANNO4 > ZERO AND ANNO4 < 2002
              ADD EARROT TO TOTALE
              COMPUTE TOTALE = TOTALE / 100
              COMPUTE TOTALE = TOTALE * 100.
           MOVE TOTALE TO RRIMB.
           MOVE 'CREDITO RESIDUO' TO CREDITI.
           MOVE 'IMPORTO CHIESTO A RIMBORSO' TO DSCR4.
           MOVE ZERO TO TOTALE.
           MOVE 2 TO XCRR.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
       NORIMB.    
           IF COMPE = ZERO GO TO NOCOMPE.
           MOVE TOTIV  TO TOTALE.
           MULTIPLY -1 BY TOTALE.
           MOVE 'TOTALE IMPORTO A CREDITO .........:' TO DESCRI.
           MOVE TOTALE TO VALORE.
           SUBTRACT COMPE  FROM TOTALE.
           MOVE TOTALE TO IMPVE.
           MOVE COMPE TO TOTALE.
           IF ANNO4 > ZERO AND ANNO4 < 2002
              ADD EARROT TO TOTALE
              COMPUTE TOTALE = TOTALE / 100
              COMPUTE TOTALE = TOTALE * 100. 
           MOVE TOTALE TO RRIMB.
           MOVE 'CREDITO RESIDUO' TO CREDITI.
           MOVE 'IMPORTO COMPENSATO MOD. F24' TO DSCR4.
           MOVE ZERO TO TOTALE.
           MOVE 2 TO XCRR.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
       NOCOMPE.
           GO TO STPRO-56.
       STPRO-53.
           IF TOTIV < T25-MIN GO TO STPRO-56.
           IF ANNO4 > ZERO AND ANNO4 < 2002
              COMPUTE TOTALE = ( TOTALE + EARROT ) / 100
              COMPUTE TOTALE = TOTALE * 100.
           MOVE 'IMPOSTA DA VERSARE ...............:' TO DESCRI.
           MOVE TOTALE TO VALORE.
           MOVE 2 TO XCRR.
           IF T25-PER = ZERO MOVE TOTALE TO IMPVE GO TO STPRO-54.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           MOVE 1 TO XCRR.
           COMPUTE IF-IMIN = ( TOTALE * T25-TAS ).
           COMPUTE IF-IMIN = ( IF-IMIN / 100 ) + 0,0049.
           IF ANNO4 > ZERO AND ANNO4 < 2002
              COMPUTE IF-IMIN = ( IF-IMIN + EARROT ) / 100
              COMPUTE IF-IMIN = IF-IMIN * 100.
           MOVE 'INTERESSI ........................:' TO DESCRI.
           MOVE IF-IMIN TO VALORE.
           ADD IF-IMIN TO TOTALE.
           MOVE TOTALE TO IMPVE.
           SUBTRACT IF-IMIN FROM TOTALE.
       STPRO-54.
           MOVE 'VERSAMENTO DI   ' TO CREDITI.
           MOVE 'EFFETTUATO IL' TO DSCR2.
           IF IF-DTVE NOT = ZERO MOVE IF-DTVE TO DTVER.
           MOVE 'A MEZZO' TO DSCR3.
           IF IF-CDBA NOT = SPACE MOVE IF-CDBA TO DSBAN.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
       STPRO-56.
      * riporto a nuovo
           MOVE ZERO TO NTRIME.
           IF MM2 = ( 1 OR 2 OR 3 ) MOVE 1 TO NTRIME.
           IF MM2 = ( 4 OR 5 OR 6 ) MOVE 2 TO NTRIME.
           IF MM2 = ( 7 OR 8 OR 9 ) MOVE 3 TO NTRIME.
           IF MM2 = ( 10 OR 11 OR 12 ) MOVE 4 TO NTRIME.
           IF IF-VP12C NOT = ZERO
              COMPUTE TOTIV = IF-VP12C * - 1.
           IF IF-VP12D NOT = ZERO 
              SUBTRACT IF-ACCV FROM IF-VP12D
              SUBTRACT IF-VP13 FROM IF-VP12D
              MOVE IF-VP12D TO TOTIV.
           IF T25-PER = ZERO AND
              NMESE = ( 3 OR 6 OR 9)
              AND IF-VP12C NOT = ZERO
              COMPUTE IF-VP12C = IF-VP12C - IF-RIMB - COMPE.
       STPRO-10.
           MOVE 2 TO XCRR.
           MOVE 'RIG2C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
      * solo stampa a carattere
           IF RP-TRPT = 1     GO TO ECHSC.
           IF NRIG NOT < NRGL GO TO ECHSC.
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO P999C.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG4C' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-C.
           COMPUTE N = NRGL - NRIG.
           COMPUTE N = N + (132 - N) / 2.
           MOVE N TO K.
           ADD 1 TO N.
       LCHSC.    
      **** rel 6.1
      *    IF NRIG NOT < (NRGL - 2) GO TO ECHSC. 
           IF NRIG NOT < (NRGL - 3) GO TO ECHSC. 
      ************
           ADD 1 TO NRIG.
      **** rel 6.1
      *    IF NRIG = (NRGL - 2)
           IF NRIG = (NRGL - 3)
      ************
              MOVE ALL '=' TO P999C 
              MOVE 'RIG4C' TO RP-BLK
           ELSE
              SUBTRACT 1 FROM N K
              MOVE '/' TO RXC(N) RXC(K)
              MOVE 'RIG3C' TO RP-BLK.
           SUBTRACT 1 FROM NRIG.  
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
      **** rel 6.1
           PERFORM STA-PIE-C.
      ************
           GO TO LCHSC.
       ECHSC.
      **** rel 6.1
      *    PERFORM STA-PIE-C.
      ************
      *
      **** rel 6.3
      *    PERFORM RPT-CL.
           PERFORM VER-CL.
      ************
       EX-LIQUID.
           EXIT.
      *------------------
       STCON.
           MOVE ZERO TO K5 TTIMP TTIVA TTIND XCRR.
           MOVE SPACE TO DESIND.
           IF IF-TPREG = 1
              MOVE 'I V A   A C Q U I S T I'     TO DSX2
              MOVE  'IMPONIBILE        IMPOSTA ' TO DESIMP
              MOVE 'INDETRAIBILE'                TO DESIND 
              GO TO STCON0.
           IF IF-TPREG = 2
              MOVE 'I V A   V E N D I T E '      TO DSX2
              MOVE  'IMPONIBILE        IMPOSTA ' TO DESIMP
           ELSE
              MOVE 'C O R R I S P E T T I V I' TO DSX2
              MOVE  ' IMP.LORDO '              TO DESIMP.
       STCON0.
      *-- inizializza parametri per stampa a caratteri --*
           IF IF-LMOD = 12
              MOVE 72 TO NRGF
              MOVE 64 TO NRGL
           ELSE
              MOVE 66 TO NRGF
              MOVE 58 TO NRGL.
           MOVE 3       TO NINT.
           MOVE C-TINTD-1 TO XTINT(1).
           MOVE C-TINTD-2 TO XTINT(2).
           MOVE C-TINTD-3 TO XTINT(3).
      *--------------------------------------------------*
      *-- inizializza parametri per stampa report --*
           MOVE KAZ-COD TO RP-CAZI.
      *
           MOVE SPACE TO RP-TIT2.
      **** rel 6.1
      *    IF IF-TPREG = 1
      *       STRING 'PROSPETTO CONTROLLO IVA ACQUISTI'
      *              DELIMITED SIZE INTO RP-TIT2.
      *    IF IF-TPREG = 2
      *       STRING 'PROSPETTO CONTROLLO IVA VENDITE'
      *              DELIMITED SIZE INTO RP-TIT2
      *    ELSE
      *       STRING 'PROSPETTO CONTROLLO CORRISPETTIVI'
      *              DELIMITED SIZE INTO RP-TIT2.
           IF IF-TPREG = 1
              STRING 'PROSPETTO CONTROLLO IVA ACQUISTI'
                     DELIMITED SIZE INTO RP-TIT2
           ELSE
              IF IF-TPREG = 2
                 STRING 'PROSPETTO CONTROLLO IVA VENDITE'
                        DELIMITED SIZE INTO RP-TIT2
              ELSE
                 STRING 'PROSPETTO CONTROLLO CORRISPETTIVI'
                        DELIMITED SIZE INTO RP-TIT2.
      ************
      *
           PERFORM RPT-RIG1D-INTC.
      *
      *    MOVE 9 TO RPT-SS-END.    *> consenti interruzione
      *---------------------------------------------*
      **** rel 7.2
           MOVE ZERO TO SIDICUI.
      ************
       STCON1.
           ADD 1 TO K5.
           IF CODIVA(K5) = ZERO GO TO STCON2.
      **** NT 7.1
      *    IF K5 > 50 GO TO STCON2.
           IF K5 > 999 GO TO STCON2.
      **********
           IF CODIVA(K5) = 999
              MOVE SPACE TO RGC1
              MOVE 'DA VENTILARE' TO RGC2
              GO TO STCON1-1.
           MOVE CODIVA(K5) TO KTB-COD.
           MOVE 3          TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RGC1.
           MOVE TAB-DESCR TO RGC2.
       STCON1-1.
           MOVE IMPCON(K5) TO RGC3.
           ADD IMPCON(K5) TO TTIMP. 
           IF IF-TPREG NOT = 3
              MOVE IVACON(K5) TO RGC4
              ADD IVACON(K5) TO TTIVA.
           IF IF-TPREG = 1
              MOVE INDCON(K5) TO RGC5
              ADD INDCON(K5) TO TTIND.
           IF IF-TPREG = 3
              MOVE 'RIG1D' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              PERFORM STA-PIE-D
           ELSE
              MOVE 'RIG1D' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              PERFORM STA-PIE-D.
      **** rel 7.2
           MOVE 1 TO SIDICUI.
      ************
           GO TO STCON1.
       STCON2.
      **** rel 7.2
           IF RP-TRPT NOT = 2
              GO TO SOLOCAR1.
      ************
           IF IF-TPREG = 1 MOVE ALL '-' TO STTAC STTVE STTCO.
           IF IF-TPREG = 2 MOVE ALL '-' TO STTAC STTVE.
           IF IF-TPREG = 3 MOVE ALL '-' TO STTAC.
           IF IF-TPREG = 3
              MOVE 2 TO RP-FLGR
              MOVE 'RIG1D' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              PERFORM STA-PIE-D
           ELSE
              MOVE 2 TO RP-FLGR
              MOVE 'RIG1D' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              PERFORM STA-PIE-D.
      **** rel 7.2
       SOLOCAR1.
           IF TTIMP = ZERO AND
              TTIVA = ZERO AND
              TTIND = ZERO
              GO TO NOTOTALI. 
      ************
      **** rel 6.3
      *    MOVE 'T O T A L I ' TO RGC2.
      *    IF TTIMP NOT = ZERO MOVE TTIMP TO RGC3.
      *    IF TTIVA NOT = ZERO MOVE TTIVA TO RGC4.
      *    IF TTIND NOT = ZERO MOVE TTIND TO RGC5.
      *    IF IF-TPREG = 1 MOVE TTIND TO RGC5.
           MOVE 'T O T A L I ' TO RGCT2.
           IF TTIMP NOT = ZERO MOVE TTIMP TO RGCT3.
           IF TTIVA NOT = ZERO MOVE TTIVA TO RGCT4.
           IF TTIND NOT = ZERO MOVE TTIND TO RGCT5.
           IF IF-TPREG = 1 MOVE TTIND TO RGCT5.
      ************
           IF IF-TPREG = 3
      **** rel 6.3
      *       MOVE 1 TO RP-FLGP
      *       MOVE 'RIG1D' TO RP-BLK
              MOVE 'RIG1TD' TO RP-BLK
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              PERFORM STA-PIE-D
           ELSE
      **** rel 6.3
      *       MOVE 1 TO RP-FLGP
      *       MOVE 'RIG1D' TO RP-BLK
      *       PERFORM RPT-WR
              MOVE 'RIG1TD' TO RP-BLK
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              PERFORM STA-PIE-D.
      **** rel 7.2
           MOVE 1 TO SIDICUI.
       NOTOTALI.
      ************
      **** rel 7.2
           PERFORM IVA-DEL-MESE  THRU EX-IVA-DEL-MESE.
           PERFORM IVA-MESE-CORR THRU EX-IVA-MESE-CORR.
           PERFORM IVA-MESE-PREC THRU EX-IVA-MESE-PREC.
      ************
      **** rel 6.3
           PERFORM STAMPA-CONTROLLO-SOSP THRU EX-STAMPA-CONTROLLO-SOSP.
      ************
      **** rel 7.2
           PERFORM STAMPA-CONTROLLO-SCIS THRU EX-STAMPA-CONTROLLO-SCIS.
      ************
       EX-STCON.
           EXIT.
      *------------------
       Z00-MEM.
           IF IF-CATT = '0' GO TO Z20.
           MOVE 35      TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE IF-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
       Z10.
           READ TABELL INTO REKT35 KEPT LOCK INVALID PERFORM INVK-TAB
                                                     GO TO ERRIO.
           IF SF-TAB NOT = ZERO PERFORM REC-LOCK
                                GO TO Z10.
           MOVE IF-UNAT TO T35-UNR.
           MOVE DT2     TO T35-DTR.
           REWRITE RF-TAB FROM REKT35 INVALID PERFORM INVK-TAB
                                              GO TO ERRIO.
           UNLOCK TABELL.
           GO TO Z40.
       Z20.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
       Z30.
           READ TABELL INTO REKT25 KEPT LOCK INVALID PERFORM INVK-TAB
                                                     GO TO ERRIO.
           IF SF-TAB NOT = ZERO PERFORM REC-LOCK
                                GO TO Z30.
           MOVE IF-UNAT TO T25-UNR.
           MOVE DT2     TO T25-DTR.
           REWRITE RF-TAB FROM REKT25 INVALID PERFORM INVK-TAB
                                              GO TO ERRIO.
           UNLOCK TABELL.
       Z40.
           IF NOT (IF-FL = 1 AND T25ESE = '1') GO TO Z99.
           CLOSE TABELL.
           MOVE 'tabell' TO ID-TAB.
           OPEN I-O TABELL.
           IF IF-CATT = '0' GO TO Z60.
           MOVE 35      TO T35-TIP.
           MOVE KAZ-COD TO T35-CDAZ.
           MOVE IF-CATT TO T35-CATT.
           MOVE T35-KEYID TO KEYTB.
       Z50.
           READ TABELL INTO REKT35 KEPT LOCK INVALID PERFORM INVK-TAB
                                                     GO TO ERRIO.
           IF SF-TAB NOT = ZERO PERFORM REC-LOCK
                                GO TO Z50.
           MOVE IF-UNAT TO T35-UNR.
           MOVE DT2     TO T35-DTR.
           REWRITE RF-TAB FROM REKT35 INVALID PERFORM INVK-TAB
                                              GO TO ERRIO.
           UNLOCK TABELL.
           GO TO Z90.
       Z60.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1'     TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
       Z70.
           READ TABELL INTO REKT25 KEPT LOCK INVALID PERFORM INVK-TAB
                                                     GO TO ERRIO.
           IF SF-TAB NOT = ZERO PERFORM REC-LOCK
                                GO TO Z70.
           MOVE IF-UNAT TO T25-UNR.
           MOVE DT2     TO T25-DTR.
           REWRITE RF-TAB FROM REKT25 INVALID PERFORM INVK-TAB
                                              GO TO ERRIO.
           UNLOCK TABELL.
       Z90.
           CLOSE TABELL.
           MOVE 'tabold' TO ID-TAB.
           OPEN I-O TABELL.
       Z99.
           EXIT.
      *------------------
       AGGLAV.
           MOVE MOV-DAT TO KLV-DAT.
           MOVE MOV-NUM TO KLV-NUM.
           IF IF-TPREG = 3
              MOVE MOV-TIP TO KLV-NPRGI
           ELSE
              MOVE MOV-NPRGI TO KLV-NPRGI.
           MOVE CIVA TO LAV-CIVA.
           IF IF-TPREG = 1 OR 3 GO TO AGL30.
           MOVE 2        TO KTB-TIP.
           MOVE MOV-CAUS TO KTB-COD.
           READ TABELL INTO REKTAB INVALID MOVE ZERO TO REKTAB.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
       AGL30.
           MOVE MOV-IVA TO KLV-IVA.
           IF IF-TPREG = 3
              MOVE ZERO TO KLV-CDCLI  
           ELSE
              MOVE MOV-PART TO KLV-CDCLI.
           MOVE MOV-NREG TO KLV-NREG.
           IF IF-TPREG     = 3    GO TO AGL40.
           IF MOV-PART NOT = ZERO GO TO AGL40.
           MOVE MOV-NUM  TO NUMMOV.
           MOVE MOV-NREG TO NUMREG.
           MOVE SPACE TO F-MES1.
           STRING 'Mov. n. ' NUMMOV ' Reg. n. ' NUMREG
                   DELIMITED BY SIZE INTO F-MES1.
           IF IF-TPREG = 1
              MOVE 'Manca codice fornitore' TO F-MES2
           ELSE
              MOVE 'Manca codice cliente  ' TO F-MES2.
           MOVE 2 TO F-NMES.
           GO TO ERRIO.
       AGL40.
           MOVE REKMOV TO LAV-RMOV.
           WRITE RF-LAV INVALID MOVE 'vcon140:errore WR LAV' TO MESS
                                GO TO ERRIO.
           ADD 1 TO CONTA.
       EX-AGGLAV.
           EXIT.
      *------------------
      * Nota: l'ID assegnato a ID-142 deve essere uguale anche
      *       in vcon142 e vcon143
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV ID-142.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
           STRING 'w9' PID DELIMITED SPACE INTO ID-142.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       REC-LOCK.
           CALL 'rlock' USING PARLK.
           EXIT.
      *------------------
       READ-DPEIVA-MESE.
           IF IF-FL = 1 MOVE 1 TO FLOLD 
           ELSE MOVE ZERO TO FLOLD.
           MOVE IF-AZI    TO CODAZI.
           MOVE MM2       TO NMESE IF-NMESE. 
           MOVE 1         TO FLRDM.
           CALL 'varc126' USING PARDMI.
           CANCEL 'varc126'.
           MOVE ZERO TO NTRIME.
           IF MM1 = ( 1 OR 2 OR 3 ) MOVE 1 TO NTRIME.
           IF MM1 = ( 4 OR 5 OR 6 ) MOVE 2 TO NTRIME.
           IF MM1 > 6               MOVE 3 TO NTRIME.
      **** rel 6.1
           IF MM1 > 9               MOVE 4 TO NTRIME.
      ************
           IF MM1 = ( 3 OR 6 OR 9 )
              MOVE P-VP19R(NTRIME) TO IF-VP19R
              MOVE P-VP19C(NTRIME) TO IF-VP19C.
           IF MM1 = ( 4 OR 7 OR 10 )
              MOVE P-VP19R(NTRIME - 1) TO IF-VP19R
              MOVE P-VP19C(NTRIME - 1) TO IF-VP19C.

           MOVE P-VP8    TO IF-VP8.
           MOVE P-VP9    TO IF-VP9.
           MOVE P-VP11   TO IF-VP11.
           MOVE P-VP13   TO IF-VP13.
       EX-READ-DPEIVA-MESE.
           EXIT.
      *----------------*
       READ-DPEIVA-ANNO.
           IF IF-FL = 1 MOVE 1 TO FLOLD 
           ELSE MOVE ZERO TO FLOLD.
           MOVE IF-AZI    TO CODAZI.
           MOVE 99        TO NMESE IF-NMESE. 
           MOVE 1         TO FLRDM.
           CALL 'varc126' USING PARDMI.
           CANCEL 'varc126'.
       EX-READ-DPEIVA-ANNO.
           EXIT.
      *----------------*
       CONTROLLO.
           MOVE ZERO TO IF-FLGERR.
           IF IF-IMDE NOT = ZERO
                 AND NMESE = ( 3 OR 6 OR 9 )
                 AND IF-VP19R NOT = ZERO
                 MOVE 'Iva dovuta rimb.infr.errato ' TO F-MES1
                 MOVE 1 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 MOVE 1 TO IF-FLGERR
                 GO TO EX-CONTROLLO.
           IF IF-IMDE NOT = ZERO
                 AND NMESE = ( 3 OR 6 OR 9 )
                 AND IF-VP19C NOT = ZERO
                 MOVE 'Iva dovuta comp.infr.errata ' TO F-MES1
                 MOVE 1 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 MOVE 1 TO IF-FLGERR
                 GO TO EX-CONTROLLO.
           COMPUTE NETCRE = IF-IMCR - IF-VP19C - IF-VP19R.
           IF IF-IMCR NOT = ZERO AND NETCRE < ZERO
                 AND NMESE = ( 3 OR 6 OR 9 )
                 MOVE 'Rimb./compens. eccedenti credito' TO F-MES1
                 MOVE 1 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 MOVE 1 TO IF-FLGERR
                 GO TO EX-CONTROLLO.
           IF IF-IMDE  = ZERO AND IF-VP13 NOT = ZERO
                 MOVE 'Iva cred. errata detr.crediti speciali' TO F-MES1
                 MOVE 1 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 MOVE 1 TO IF-FLGERR
                 GO TO EX-CONTROLLO.
           COMPUTE NETCRE = IF-IMDE - IF-VP13.
           IF IF-IMDE NOT = ZERO AND NETCRE < ZERO
                 MOVE 'Crediti spec. eccedenti debito ' TO F-MES1
                 MOVE 1 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 MOVE 1 TO IF-FLGERR
                 GO TO EX-CONTROLLO.
       EX-CONTROLLO.
           EXIT.
      *----------------*
      **** rel 6.3
       STAMPA-CONTROLLO-SOSP.
           IF IF-TPREG NOT = 2 GO TO EX-STAMPA-CONTROLLO-SOSP.
           IF FSA-CODIVA(1) = ZERO AND
              FSP-CODIVA(1) = ZERO AND
              FSI-CODIVA(1) = ZERO GO TO EX-STAMPA-CONTROLLO-SOSP.
      *
           PERFORM RPT-RIG1D-INTC.
      *
           MOVE ZERO TO K5 TTIMP TTIVA TTIND.
      *
           MOVE 1 TO FLGST.
           MOVE 1 TO NINT.
      *
      **** rel 7.2
           IF SIDICUI = 1
      ************
           IF IF-INCSOS = ZERO
              MOVE 1 TO XCRR
              MOVE 'RIG0D' TO RP-BLK
              PERFORM RPT-WR1 THRU EX-RPT-WR1
              PERFORM STA-PIE-D
      *
      **** rel 7.2
              MOVE ZERO TO SIDICUI
      ************
              MOVE 1 TO XCRR
              MOVE 'DI CUI :' TO P000D
              MOVE 'RIG0D' TO RP-BLK
              PERFORM RPT-WR1 THRU EX-RPT-WR1
              PERFORM STA-PIE-D.
      *
           IF FSA-CODIVA(1) = ZERO GO TO NO-FSA.
      *
           MOVE 1 TO XCRR.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 1 TO XCRR.
           MOVE 'INCASSO FATTURE IN SOSPESO DELL''ANNO' TO P000D.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 2 TO XCRR.
           MOVE C-TINTD-2(2:) TO P999D.
           MOVE 'RIG3D' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
       STCON1-FSA.
           ADD 1 TO K5.
           IF FSA-CODIVA(K5) = ZERO GO TO STCON2-FSA.
      **** rel 7.1
      *    IF K5 > 50 GO TO STCON2-FSA.
           IF K5 > 999 GO TO STCON2-FSA.
      ************
           IF FSA-CODIVA(K5) = 999
              MOVE SPACE TO RGC1
              MOVE 'DA VENTILARE' TO RGC2
              GO TO STCON1-1-FSA.
           MOVE FSA-CODIVA(K5) TO KTB-COD.
           MOVE 3              TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RGC1.
           MOVE TAB-DESCR TO RGC2.
       STCON1-1-FSA.
           MOVE FSA-IMPCON(K5) TO RGC3.
           ADD FSA-IMPCON(K5) TO TTIMP.
           MOVE FSA-IVACON(K5) TO RGC4.
           ADD FSA-IVACON(K5) TO TTIVA.
           MOVE 'RIG1D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           GO TO STCON1-FSA.
       STCON2-FSA.
           MOVE ALL '-' TO STTVE STTAC.
           MOVE 'RIG1D' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
           MOVE 'T O T A L I ' TO  RGCT2.
           IF TTIMP NOT = ZERO MOVE TTIMP TO RGCT3.
           IF TTIVA NOT = ZERO MOVE TTIVA TO RGCT4.
           IF TTIND NOT = ZERO MOVE TTIND TO RGCT5.
           MOVE 'RIG1TD' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
       NO-FSA.
           IF FSP-CODIVA(1) = ZERO GO TO NO-FSP.
      *
           MOVE ZERO TO K5 TTIMP TTIVA TTIND.
      *
           MOVE 1 TO XCRR.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 1 TO XCRR.
           MOVE 'INCASSO FATTURE IN SOSPESO ANNI PRECEDENTI' TO P000D.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 2 TO XCRR.
           MOVE C-TINTD-2(2:) TO P999D.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
      *
       STCON1-FSP.
           ADD 1 TO K5.
           IF FSP-CODIVA(K5) = ZERO GO TO STCON2-FSP.
      **** rel 7.1
      *    IF K5 > 50 GO TO STCON2-FSP.
           IF K5 > 999 GO TO STCON2-FSP.
      ************
           IF FSP-CODIVA(K5) = 999
              MOVE SPACE TO RGC1
              MOVE 'DA VENTILARE' TO RGC2
              GO TO STCON1-1-FSP.
           MOVE FSP-CODIVA(K5) TO KTB-COD.
           MOVE 3              TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RGC1.
           MOVE TAB-DESCR TO RGC2.
       STCON1-1-FSP.
           MOVE FSP-IMPCON(K5) TO RGC3.
           ADD FSP-IMPCON(K5) TO TTIMP.
           MOVE FSP-IVACON(K5) TO RGC4.
           ADD FSP-IVACON(K5) TO TTIVA.
           MOVE 'RIG1D' TO RP-BLK
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
           GO TO STCON1-FSP.
       STCON2-FSP.
           MOVE ALL '-' TO STTVE STTAC.
           MOVE 'RIG1D' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
           MOVE 'T O T A L I ' TO  RGCT2.
           IF TTIMP NOT = ZERO MOVE TTIMP TO RGCT3.
           IF TTIVA NOT = ZERO MOVE TTIVA TO RGCT4.
           IF TTIND NOT = ZERO MOVE TTIND TO RGCT5.
           MOVE 'RIG1TD' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
      *
       NO-FSP.
      **** rel 7.2
      *    IF IF-INCSOS = 1 GO TO NO-FSI.
      ************
      *
           IF FSI-CODIVA(1) = ZERO GO TO NO-FSI.
      *
           MOVE ZERO TO K5 TTIMP TTIVA TTIND.
      *
           MOVE 1 TO XCRR.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
      **** rel 7.2
           MOVE ALL '=' TO P999D.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      *
           MOVE ALL '=' TO P000D.
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      *
      ************
           MOVE 1 TO XCRR.
      **** rel 7.2
      *    MOVE 'FATTURE IN SOSPESO DA INCASSARE' TO P000D.
           MOVE 'FATTURE EMESSE CON IVA AD ESIGIBILITA'' DIFFERITA' 
                TO P000D.
      ************
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 2 TO XCRR.
           MOVE C-TINTD-2(2:) TO P999D.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
      *
       STCON1-FSI.
           ADD 1 TO K5.
           IF FSI-CODIVA(K5) = ZERO GO TO STCON2-FSI.
      **** rel 7.1
      *    IF K5 > 50 GO TO STCON2-FSI.
           IF K5 > 999 GO TO STCON2-FSI.
      ************
           IF FSI-CODIVA(K5) = 999
              MOVE SPACE TO RGC1
              MOVE 'DA VENTILARE' TO RGC2
              GO TO STCON1-1-FSI.
           MOVE FSI-CODIVA(K5) TO KTB-COD.
           MOVE 3              TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RGC1.
           MOVE TAB-DESCR TO RGC2.
       STCON1-1-FSI.
           MOVE FSI-IMPCON(K5) TO RGC3.
           ADD FSI-IMPCON(K5) TO TTIMP.
           MOVE FSI-IVACON(K5) TO RGC4.
           ADD FSI-IVACON(K5) TO TTIVA.
           MOVE 'RIG1D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
           GO TO STCON1-FSI.
       STCON2-FSI.
           MOVE ALL '-' TO STTVE STTAC.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
           MOVE 'T O T A L I ' TO  RGCT2.
           IF TTIMP NOT = ZERO MOVE TTIMP TO RGCT3.
           IF TTIVA NOT = ZERO MOVE TTIVA TO RGCT4.
           IF TTIND NOT = ZERO MOVE TTIND TO RGCT5.
           MOVE 'RIG1TD' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
       NO-FSI.
       EX-STAMPA-CONTROLLO-SOSP.
           EXIT.
      ************
      **** rel 7.2
       STAMPA-CONTROLLO-SCIS.
           IF IF-TPREG NOT = 2 GO TO EX-STAMPA-CONTROLLO-SCIS.
           IF SFSA-CODIVA(1) = ZERO AND
              SFSP-CODIVA(1) = ZERO AND
              SFSI-CODIVA(1) = ZERO GO TO EX-STAMPA-CONTROLLO-SCIS.
      *
           PERFORM RPT-RIG1D-INTC.
      *
           MOVE ZERO TO K5 TTIMP TTIVA TTIND.
      *
           MOVE 1 TO FLGST.
           MOVE 1 TO NINT.
      *
           IF IF-INCSOS = ZERO
              MOVE 1 TO XCRR
              MOVE 'RIG0D' TO RP-BLK
              PERFORM RPT-WR1 THRU EX-RPT-WR1
              PERFORM STA-PIE-D
      *
              MOVE 1 TO XCRR
              MOVE 'DI CUI :' TO P000D
              MOVE 'RIG0D' TO RP-BLK
              PERFORM RPT-WR1 THRU EX-RPT-WR1
              PERFORM STA-PIE-D.
      *
           IF SFSA-CODIVA(1) = ZERO GO TO NO-SFSA.
      *
           MOVE 1 TO XCRR.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 1 TO XCRR.
           MOVE 'INCASSO FATTURE IN SOSPESO DELL''ANNO' TO P000D.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 2 TO XCRR.
           MOVE C-TINTD-2(2:) TO P999D.
           MOVE 'RIG3D' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
       STCON1-SFSA.
           ADD 1 TO K5.
           IF SFSA-CODIVA(K5) = ZERO GO TO STCON2-SFSA.
           IF K5 > 999 GO TO STCON2-SFSA.
           IF SFSA-CODIVA(K5) = 999
              MOVE SPACE TO RGC1
              MOVE 'DA VENTILARE' TO RGC2
              GO TO STCON1-1-SFSA.
           MOVE SFSA-CODIVA(K5) TO KTB-COD.
           MOVE 3              TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RGC1.
           MOVE TAB-DESCR TO RGC2.
       STCON1-1-SFSA.
           MOVE SFSA-IMPCON(K5) TO RGC3.
           ADD SFSA-IMPCON(K5) TO TTIMP.
           MOVE SFSA-IVACON(K5) TO RGC4.
           ADD SFSA-IVACON(K5) TO TTIVA.
           MOVE 'RIG1D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           GO TO STCON1-SFSA.
       STCON2-SFSA.
           MOVE ALL '-' TO STTVE STTAC.
           MOVE 'RIG1D' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
           MOVE 'T O T A L I ' TO  RGCT2.
           IF TTIMP NOT = ZERO MOVE TTIMP TO RGCT3.
           IF TTIVA NOT = ZERO MOVE TTIVA TO RGCT4.
           IF TTIND NOT = ZERO MOVE TTIND TO RGCT5.
           MOVE 'RIG1TD' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
       NO-SFSA.
           IF SFSP-CODIVA(1) = ZERO GO TO NO-SFSP.
      *
           MOVE ZERO TO K5 TTIMP TTIVA TTIND.
      *
           MOVE 1 TO XCRR.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 1 TO XCRR.
           MOVE 'INCASSO FATTURE IN SOSPESO ANNI PRECEDENTI' TO P000D.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 2 TO XCRR.
           MOVE C-TINTD-2(2:) TO P999D.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
      *
       STCON1-SFSP.
           ADD 1 TO K5.
           IF SFSP-CODIVA(K5) = ZERO GO TO STCON2-SFSP.
           IF K5 > 999 GO TO STCON2-SFSP.
           IF SFSP-CODIVA(K5) = 999
              MOVE SPACE TO RGC1
              MOVE 'DA VENTILARE' TO RGC2
              GO TO STCON1-1-SFSP.
           MOVE SFSP-CODIVA(K5) TO KTB-COD.
           MOVE 3              TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RGC1.
           MOVE TAB-DESCR TO RGC2.
       STCON1-1-SFSP.
           MOVE SFSP-IMPCON(K5) TO RGC3.
           ADD SFSP-IMPCON(K5) TO TTIMP.
           MOVE SFSP-IVACON(K5) TO RGC4.
           ADD SFSP-IVACON(K5) TO TTIVA.
           MOVE 'RIG1D' TO RP-BLK
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
           GO TO STCON1-SFSP.
       STCON2-SFSP.
           MOVE ALL '-' TO STTVE STTAC.
           MOVE 'RIG1D' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
           MOVE 'T O T A L I ' TO  RGCT2.
           IF TTIMP NOT = ZERO MOVE TTIMP TO RGCT3.
           IF TTIVA NOT = ZERO MOVE TTIVA TO RGCT4.
           IF TTIND NOT = ZERO MOVE TTIND TO RGCT5.
           MOVE 'RIG1TD' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
      *
       NO-SFSP.
      *
           IF SFSI-CODIVA(1) = ZERO GO TO NO-SFSI.
      *
           MOVE ZERO TO K5 TTIMP TTIVA TTIND.
      *
           MOVE 1 TO XCRR.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
      **** rel 7.2
           MOVE ALL '=' TO P999D.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      *
           MOVE ALL '=' TO P000D.
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      *
      ************
           MOVE 1 TO XCRR.
           MOVE 'FATTURE EMESSE CON MECCANISMO DI SCISSIONE PAGAMENTO'
                TO P000D.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 2 TO XCRR.
           MOVE C-TINTD-2(2:) TO P999D.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
      *
       STCON1-SFSI.
           ADD 1 TO K5.
           IF SFSI-CODIVA(K5) = ZERO GO TO STCON2-SFSI.
           IF K5 > 999 GO TO STCON2-SFSI.
           IF SFSI-CODIVA(K5) = 999
              MOVE SPACE TO RGC1
              MOVE 'DA VENTILARE' TO RGC2
              GO TO STCON1-1-SFSI.
           MOVE SFSI-CODIVA(K5) TO KTB-COD.
           MOVE 3              TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RGC1.
           MOVE TAB-DESCR TO RGC2.
       STCON1-1-SFSI.
           MOVE SFSI-IMPCON(K5) TO RGC3.
           ADD SFSI-IMPCON(K5) TO TTIMP.
           MOVE SFSI-IVACON(K5) TO RGC4.
           ADD SFSI-IVACON(K5) TO TTIVA.
           MOVE 'RIG1D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
           GO TO STCON1-SFSI.
       STCON2-SFSI.
           MOVE ALL '-' TO STTVE STTAC.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG1D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
           MOVE 'T O T A L I ' TO  RGCT2.
           IF TTIMP NOT = ZERO MOVE TTIMP TO RGCT3.
           IF TTIVA NOT = ZERO MOVE TTIVA TO RGCT4.
           IF TTIND NOT = ZERO MOVE TTIND TO RGCT5.
           MOVE 'RIG1TD' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
       NO-SFSI.
       EX-STAMPA-CONTROLLO-SCIS.
           EXIT.
      ************
      *----------------*
       BARTOT.
      * solo stampa a carattere
           IF RP-TRPT = 1     GO TO EX-BARTOT.
           IF NRIG NOT < NRGL GO TO EX-BARTOT.
           MOVE 1 TO XCRR.
           MOVE ALL '=' TO P999D.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3D' TO RP-BLK.
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
           PERFORM STA-PIE-D.
           COMPUTE N = NRGL - NRIG.
           COMPUTE N = N + (132 - N) / 2.
           MOVE N TO K.
           ADD 1 TO N.
       LCHS-TOT.    
      **** rel 6.1
      *    IF NRIG NOT < (NRGL - 2) GO TO EX-BARTOT. 
           IF NRIG NOT < (NRGL - 3) GO TO EX-BARTOT. 
      ************
           ADD 1 TO NRIG.
      **** rel 6.1
      *    IF NRIG = (NRGL - 2)
           IF NRIG = (NRGL - 3)
      ************
              MOVE ALL '=' TO P999D 
              MOVE 'RIG3D' TO RP-BLK
           ELSE
              SUBTRACT 1 FROM N K
              IF N NOT = ZERO AND K NOT = ZERO 
                 MOVE '/' TO RXD(N) RXD(K)
                 MOVE 'RIG2D' TO RP-BLK
              ELSE
                 GO TO EX-BARTOT.
           SUBTRACT 1 FROM NRIG.   
      **** rel 6.3
      *    PERFORM RPT-WR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
      **** rel 6.1
           PERFORM STA-PIE-D.
      ************
           GO TO LCHS-TOT.
       EX-BARTOT.
      **** rel 6.1
      *    PERFORM STA-PIE-D.
      ************
           EXIT.
      *------------------*
       STA-PIE.
      **** rel 6.1
      *    IF IF-NBOL = 1 AND (NRIG NOT < (NRGL - 2))
           IF IF-NBOL = 1 AND (NRIG NOT < (NRGL - 3))
              MOVE 2 TO RP-FLGR
              MOVE 'RIG4' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
      ************
              MOVE IF-PIEDE-1 TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG4' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              MOVE IF-PIEDE-2 TO P999
              MOVE 2 TO RP-FLGR
              MOVE 'RIG4' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR.
              PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
      *------------------*
       STA-PIE-B.
      **** rel 6.1
      *    IF IF-NBOL = 1 AND (NRIG NOT < (NRGL - 2))
           IF IF-NBOL = 1 AND (NRIG NOT < (NRGL - 3))
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3B' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
      ************
              MOVE IF-PIEDE-1 TO P999B
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3B' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              MOVE IF-PIEDE-2 TO P999B
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3B' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR.
              PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
      *------------------*
       STA-PIE-C.
      **** rel 6.1
      *    IF IF-NBOL = 1 AND (NRIG NOT < (NRGL - 2))
           IF IF-NBOL = 1 AND (NRIG NOT < (NRGL - 3))
              MOVE 2 TO RP-FLGR
              MOVE 'RIG4C' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
      ************
              MOVE IF-PIEDE-1 TO P999C
              MOVE 2 TO RP-FLGR
              MOVE 'RIG4C' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              MOVE IF-PIEDE-2 TO P999C
              MOVE 2 TO RP-FLGR
              MOVE 'RIG4C' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR.
              PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
      *------------------*
       STA-PIE-D.
      **** rel 7.2
           IF RP-TRPT = 2
      ************
      **** rel 6.1
      *    IF IF-NBOL = 1 AND (NRIG NOT < (NRGL - 2))
           IF IF-NBOL = 1 AND (NRIG NOT < (NRGL - 3))
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3D' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
      ************
              MOVE IF-PIEDE-1 TO P999D
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3D' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR
              PERFORM RPT-WR1 THRU EX-RPT-WR1
      ************
              MOVE IF-PIEDE-2 TO P999D
              MOVE 2 TO RP-FLGR
              MOVE 'RIG3D' TO RP-BLK
      **** rel 6.3
      *       PERFORM RPT-WR.
              PERFORM RPT-WR1 THRU EX-RPT-WR1.
      ************
      *------------------*
       RPT-RIG1-INTC.
           MOVE 'RIG1' TO RP-BLK.
      *
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Progr.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Ragione Sociale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'N.Doc' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imponibile' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Aliquota' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imposta' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Note' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
       RPT-RIG1B-INTC.
           MOVE 'RIG1B' TO RP-BLK.
      *
           MOVE 'Data' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Non soggetti a Ricevuta Fiscale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Soggetti a Ricevuta Fiscale' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Aliquote' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Note' TO RP-IFLD.
           PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
       RPT-RIG1C-INTC.
           MOVE 'RIG1C' TO RP-BLK.
      *
           MOVE 'Cod.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione Iva' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imponibile Vendite' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imposta Vendite' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imponibile Acquisti' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Imposta Acquisti' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Indetraibile Acquisti' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           IF IV-CDCOR NOT = ZERO
              MOVE 'Imponibile Lordo Corrispettivi' TO RP-IFLD
              PERFORM RPT-ADD-I
              MOVE 'Imponibile Corrispettivi' TO RP-IFLD
              PERFORM RPT-ADD-I
              MOVE 'Imposta Corrispettivi' TO RP-IFLD
              PERFORM RPT-ADD-I
           ELSE
              PERFORM RPT-ADD-I
              PERFORM RPT-ADD-I
              PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
       RPT-RIG1D-INTC.
           MOVE 'RIG1D' TO RP-BLK.
      *
           MOVE 'Cod.' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           MOVE 'Descrizione Iva' TO RP-IFLD.
           PERFORM RPT-ADD-I.
           IF IF-TPREG = 1 
              MOVE 'Imponibile' TO RP-IFLD 
              PERFORM RPT-ADD-I
              MOVE 'Imposta' TO RP-IFLD
              PERFORM RPT-ADD-I
              MOVE 'Indetraibile' TO RP-IFLD
              PERFORM RPT-ADD-I.
           IF IF-TPREG = 2 
              MOVE 'Imponibile' TO RP-IFLD 
              PERFORM RPT-ADD-I
              MOVE 'Imposta' TO RP-IFLD
              PERFORM RPT-ADD-I
              PERFORM RPT-ADD-I.
           IF IF-TPREG = 3 
              MOVE 'Imp. Lordo' TO RP-IFLD
              PERFORM RPT-ADD-I
              PERFORM RPT-ADD-I
              PERFORM RPT-ADD-I.
      *--*
           PERFORM RPT-CLOSE-I.
      *------------------
      **** rel 6.3
       RPT-WR1.
           IF FLGST = ZERO
              PERFORM RPT-AZZ
           ELSE
              PERFORM RPT-WR.
       EX-RPT-WR1.
      *------------------
      ************
      **** rel 7.2
       VERIFICA-CONDIZIONE.
          MOVE ZERO TO PARGISO.
          MOVE IF-AZI    TO PGISO-AZI.
          MOVE IF-FL     TO PGISO-FL.
          MOVE MOV-NREG  TO PGISO-NREG.
          MOVE MOV-DAT   TO PGISO-DTREG.
          CALL 'vrcgiso-72' USING PARGISO.
       EX-VERIFICA-CONDIZIONE.
           EXIT.
      *------------------
      **** rel 7.2
       IVA-IVN.
      *
           MOVE ZERO TO K6.
      *
       NX-IVA-IVN.
      *
           ADD 1 TO K6.
           IF K6 > 999 GO TO FN-IVA-IVN.
      *
           IF CODIVA(K6) = ZERO
              MOVE COMIVA TO CODIVA(K6).

           IF CODIVA(K6) NOT = COMIVA GO TO NX-IVA-IVN.

           ADD COMIVN TO INDCON(K6).
      *
       FN-IVA-IVN.
      *
       EX-IVA-IVN.
           EXIT.
      *------------------
       MESE-PREC.
      *
           MOVE ZERO TO K6.
      *
       NX-MESE-PREC.
      *
           ADD 1 TO K6.
           IF K6 > 999 GO TO FN-MESE-PREC.
      *
           IF MPR-CODIVA(K6) = ZERO
              MOVE COMIVA TO MPR-CODIVA(K6).

           IF MPR-CODIVA(K6) NOT = COMIVA GO TO NX-MESE-PREC.

           IF W-IND = ZERO
              ADD COMIMP  TO MPR-IMPCON(K6)
              ADD COMIMPO TO MPR-IVACON(K6)
           ELSE
              ADD COMIVN  TO MPR-INDCON(K6)
           END-IF.
      *
       FN-MESE-PREC.
      *
       EX-MESE-PREC.
           EXIT.
      *------------------
       IVA-D-MESE.
      *
           MOVE ZERO TO K6.
      *
       NX-IVA-D-MESE.
      *
           ADD 1 TO K6.
           IF K6 > 999 GO TO FN-IVA-D-MESE.
      *
           IF MDM-CODIVA(K6) = ZERO
              MOVE COMIVA TO MDM-CODIVA(K6).

           IF MDM-CODIVA(K6) NOT = COMIVA GO TO NX-IVA-D-MESE.

           IF W-IND = ZERO
              ADD COMIMP  TO MDM-IMPCON(K6)
              ADD COMIMPO TO MDM-IVACON(K6)
           ELSE
              ADD COMIVN  TO MDM-INDCON(K6)
           END-IF.
      *
       FN-IVA-D-MESE.
      *
       EX-IVA-D-MESE.
           EXIT.
      *------------------
       MESE-CORR.
      *
           MOVE ZERO TO K6.
      *
       NX-MESE-CORR.
      *
           ADD 1 TO K6.
           IF K6 > 999 GO TO FN-MESE-CORR.
      *
           IF MCO-CODIVA(K6) = ZERO
              MOVE COMIVA TO MCO-CODIVA(K6).

           IF MCO-CODIVA(K6) NOT = COMIVA GO TO NX-MESE-CORR.

           IF W-IND = ZERO
              ADD COMIMP  TO MCO-IMPCON(K6)
              ADD COMIMPO TO MCO-IVACON(K6)
           ELSE
              ADD COMIVN  TO MCO-INDCON(K6)
           END-IF.
      *
       FN-MESE-CORR.
      *
       EX-MESE-CORR.
           EXIT.
      *------------------
       IVA-DEL-MESE.
      *
           IF IF-TPREG = 3 GO TO EX-IVA-DEL-MESE.
      *
           IF MCO-CODIVA(1) = ZERO AND
              MCO-IMPCON(1) = ZERO AND
              MCO-IVACON(1) = ZERO
                           GO TO EX-IVA-DEL-MESE.
      *
           IF MDM-CODIVA(1) = ZERO AND
              MDM-IMPCON(1) = ZERO AND
              MDM-IVACON(1) = ZERO
                           GO TO EX-IVA-DEL-MESE.
      *
           PERFORM RPT-RIG1D-INTC.
      *
           MOVE ZERO TO K5 TTIMP TTIVA TTIND.
      *
           MOVE 1 TO FLGST.
           MOVE 1 TO NINT.
      *
           MOVE 1 TO XCRR
           MOVE 'RIG0D' TO RP-BLK
           PERFORM RPT-WR1 THRU EX-RPT-WR1
           PERFORM STA-PIE-D
      *
           MOVE 1 TO XCRR
           MOVE 'DI CUI :' TO P000D
           MOVE 'RIG0D' TO RP-BLK
           PERFORM RPT-WR1 THRU EX-RPT-WR1
           PERFORM STA-PIE-D.
      *
           IF MDM-CODIVA(1) = ZERO GO TO NO-MDM.
      *
           MOVE 1 TO XCRR.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 1 TO XCRR.
           MOVE 'RIEPILOGO IVA PERIODO ' TO P000D.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 2 TO XCRR.
           MOVE C-TINTD-2(2:) TO P999D.
           MOVE 'RIG3D' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
       STCON1-MDM.
           ADD 1 TO K5.
           IF MDM-CODIVA(K5) = ZERO GO TO STCON2-MDM.
           IF K5 > 999 GO TO STCON2-MDM.
           IF MDM-CODIVA(K5) = 999
              MOVE SPACE TO RGC1
              MOVE 'DA VENTILARE' TO RGC2
              GO TO STCON1-1-MDM.
           MOVE MDM-CODIVA(K5) TO KTB-COD.
           MOVE 3              TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RGC1.
           MOVE TAB-DESCR TO RGC2.
       STCON1-1-MDM.
           MOVE MDM-IMPCON(K5) TO RGC3.
           ADD  MDM-IMPCON(K5) TO TTIMP.
           MOVE MDM-IVACON(K5) TO RGC4.
           ADD  MDM-IVACON(K5) TO TTIVA.
           MOVE MDM-INDCON(K5) TO RGC5.
           ADD  MDM-INDCON(K5) TO TTIND.
           MOVE 'RIG1D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           GO TO STCON1-MDM.
       STCON2-MDM.
           MOVE ALL '-' TO STTVE STTAC.
           MOVE 'RIG1D' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
           MOVE 'T O T A L I ' TO  RGCT2.
           IF TTIMP NOT = ZERO MOVE TTIMP TO RGCT3.
           IF TTIVA NOT = ZERO MOVE TTIVA TO RGCT4.
           IF TTIND NOT = ZERO MOVE TTIND TO RGCT5.
           MOVE 'RIG1TD' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
       NO-MDM.
      *
       EX-IVA-DEL-MESE.
           EXIT.
      *--------------------------*
       IVA-MESE-CORR.
      *
           IF IF-TPREG = 3 GO TO EX-IVA-MESE-CORR.
      *
           IF MCO-CODIVA(1) = ZERO AND
              MCO-IMPCON(1) = ZERO AND
              MCO-IVACON(1) = ZERO
                           GO TO EX-IVA-MESE-CORR.
      *
           PERFORM RPT-RIG1D-INTC.
      *
           MOVE ZERO TO K5 TTIMP TTIVA TTIND.
      *
           MOVE 1 TO FLGST.
           MOVE 1 TO NINT.
      *
           MOVE 1 TO XCRR
           MOVE 'RIG0D' TO RP-BLK
           PERFORM RPT-WR1 THRU EX-RPT-WR1
           PERFORM STA-PIE-D
      *
           IF MCO-CODIVA(1) = ZERO GO TO NO-MCO.
      *
           MOVE 1 TO XCRR.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 1 TO XCRR.
           MOVE 'RIEPILOGO IVA COMPETENZA PERIODO CORRENTE ' TO P000D.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 2 TO XCRR.
           MOVE C-TINTD-2(2:) TO P999D.
           MOVE 'RIG3D' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
       STCON1-MCO.
           ADD 1 TO K5.
           IF MCO-CODIVA(K5) = ZERO GO TO STCON2-MCO.
           IF K5 > 999 GO TO STCON2-MCO.
           IF MCO-CODIVA(K5) = 999
              MOVE SPACE TO RGC1
              MOVE 'DA VENTILARE' TO RGC2
              GO TO STCON1-1-MCO.
           MOVE MCO-CODIVA(K5) TO KTB-COD.
           MOVE 3              TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RGC1.
           MOVE TAB-DESCR TO RGC2.
       STCON1-1-MCO.
           MOVE MCO-IMPCON(K5) TO RGC3.
           ADD  MCO-IMPCON(K5) TO TTIMP.
           MOVE MCO-IVACON(K5) TO RGC4.
           ADD  MCO-IVACON(K5) TO TTIVA.
           MOVE MCO-INDCON(K5) TO RGC5.
           ADD  MCO-INDCON(K5) TO TTIND.
           MOVE 'RIG1D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           GO TO STCON1-MCO.
       STCON2-MCO.
           MOVE ALL '-' TO STTVE STTAC.
           MOVE 'RIG1D' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
           MOVE 'T O T A L I ' TO  RGCT2.
           IF TTIMP NOT = ZERO MOVE TTIMP TO RGCT3.
           IF TTIVA NOT = ZERO MOVE TTIVA TO RGCT4.
           IF TTIND NOT = ZERO MOVE TTIND TO RGCT5.
           MOVE 'RIG1TD' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
       NO-MCO.
      *
       EX-IVA-MESE-CORR.
           EXIT.
      *------------------
       IVA-MESE-PREC.
      *
           IF IF-TPREG = 3 GO TO EX-IVA-MESE-PREC.
      *
           IF MPR-CODIVA(1) = ZERO AND
              MPR-IMPCON(1) = ZERO AND
              MPR-IVACON(1) = ZERO
                           GO TO EX-IVA-MESE-PREC.
      *
           PERFORM RPT-RIG1D-INTC.
      *
           MOVE ZERO TO K5 TTIMP TTIVA TTIND.
      *
           MOVE 1 TO FLGST.
           MOVE 1 TO NINT.
      *
           MOVE 1 TO XCRR
           MOVE 'RIG0D' TO RP-BLK
           PERFORM RPT-WR1 THRU EX-RPT-WR1
           PERFORM STA-PIE-D
      *
           IF MPR-CODIVA(1) = ZERO GO TO NO-MPR.
      *
           MOVE ALL '=' TO P999D.
           MOVE 2 TO RP-FLGR.
           MOVE 'RIG3D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      *
           MOVE ALL '=' TO P000D.
           MOVE 1 TO RP-FLGR.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
      *
           MOVE 1 TO XCRR.
           MOVE 'RIEPILOGO IVA COMPETENZA PERIODO PRECEDENTE ' TO P000D.
           MOVE 'RIG0D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
           MOVE 2 TO XCRR.
           MOVE C-TINTD-2(2:) TO P999D.
           MOVE 'RIG3D' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
       STCON1-MPR.
           ADD 1 TO K5.
           IF MPR-CODIVA(K5) = ZERO GO TO STCON2-MPR.
           IF K5 > 999 GO TO STCON2-MPR.
           IF MPR-CODIVA(K5) = 999
              MOVE SPACE TO RGC1
              MOVE 'DA VENTILARE' TO RGC2
              GO TO STCON1-1-MPR.
           MOVE MPR-CODIVA(K5) TO KTB-COD.
           MOVE 3              TO KTB-TIP.
           READ TABELL INTO REKTAB INVALID PERFORM INVK-TAB
                                           GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T03-DSIVA TO RGC1.
           MOVE TAB-DESCR TO RGC2.
       STCON1-1-MPR.
           MOVE MPR-IMPCON(K5) TO RGC3.
           ADD  MPR-IMPCON(K5) TO TTIMP.
           MOVE MPR-IVACON(K5) TO RGC4.
           ADD  MPR-IVACON(K5) TO TTIVA.
           MOVE MPR-INDCON(K5) TO RGC5.
           ADD  MPR-INDCON(K5) TO TTIND.
           MOVE 'RIG1D' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           GO TO STCON1-MPR.
       STCON2-MPR.
           MOVE ALL '-' TO STTVE STTAC.
           MOVE 'RIG1D' TO RP-BLK.
           MOVE 2 TO RP-FLGR.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
           MOVE 1 TO XCRR.
           MOVE 'T O T A L I ' TO  RGCT2.
           IF TTIMP NOT = ZERO MOVE TTIMP TO RGCT3.
           IF TTIVA NOT = ZERO MOVE TTIVA TO RGCT4.
           IF TTIND NOT = ZERO MOVE TTIND TO RGCT5.
           MOVE 'RIG1TD' TO RP-BLK.
           PERFORM RPT-WR1 THRU EX-RPT-WR1.
           PERFORM STA-PIE-D.
      *
       NO-MPR.
      *
       EX-IVA-MESE-PREC.
           EXIT.
      *------------------
      ************
